
##############################################################################################
#                                                                                            #
#   BioIndex v.3.2                                                                           #
#   Developed on R 4.1.2 (x86-64bit)                                                         #
#   March, 2022                                                                              #
#                                                                                            #
#   Authors:                                                                                 #
#   Walter Zupa, Loredana Casciaro, Isabella Bitetto, Maria Teresa Spedicato                 #
#   Coispa Tecnologia & Ricerca - Stazione sperimentale per lo Studio delle Risorse del Mare #
#                                                                                            #
#   In case of use of the software, the Authors should be cited.                             #
#   If you have any comments or suggestions please contact the following e-mail address:     #
#   zupa@coispa.it                                                                           #
#   BioIndex is believed to be reliable. However, we disclaim any implied warranty or        #
#   representation about its accuracy, completeness or appropriateness for any particular    #
#   purpose.                                                                                 #
#                                                                                            #
#   doi: 10.5281/zenodo.6389406                                                              #
#                                                                                            #
##############################################################################################

rm(list=ls(all=TRUE))

#--------------------------------------------------------------
# Selection of the working directory
#--------------------------------------------------------------
# install.packages("tcltk2")
library(tcltk2)
wd <- tk_choose.dir(getwd(), "Choose a suitable folder")
setwd(wd)

#--------------------------------------------------------------
# initialization
#--------------------------------------------------------------
source(paste(wd, "/scripts/01_intro.r", sep=""))

#--------------------------------------------------------------
# Data analysis
#--------------------------------------------------------------
source(paste(wd, "/scripts/02_Data_analysis.r", sep=""))
