wmap <- readOGR(dsn=paste(wd,"/scripts/utilities/continent/ne_10m_land.shp", sep=""), layer="ne_10m_land", verbose =F)
countries <- readOGR(paste(wd,"/scripts/utilities/continent/ne_10m_admin_0_countries.shp", sep=""), layer="ne_10m_admin_0_countries", verbose =F)
metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]


if (nrow(map_range)>1) {
  if (check_country=="Y") {
    x1 <- min(map_range$xmin)
    x2 <- max(map_range$xmax)
    y1 <- min(map_range$ymin)
    y2 <- max(map_range$ymax)
    map_range <- map_range[1,]
    map_range[1,3] <- x1
    map_range[1,4] <- x2
    map_range[1,5] <- y1
    map_range[1,6] <- y2
  }
}

# ################################

#### selection of map limits by file ####

map_lim  <- as.numeric(map_range[,3:6])
lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
map_ratio <- ly/lx

limits <- data.frame(matrix(NA,ncol=2, nrow=2))
colnames(limits)<- c("X","Y")
limits[1,1]<- map_lim[1]
limits[1,2]<- map_lim[3]
limits[2,1]<- map_lim[2]
limits[2,2]<- map_lim[4]
coordinates(limits) <- ~ X+Y
proj4string(limits) <- CRS("+proj=longlat")
lim_laea<-as.data.frame(spTransform(limits, CRS("+proj=longlat")))
xmin<-lim_laea[1,1]
xmax<-lim_laea[2,1]
ymin<-lim_laea[1,2]
ymax<-lim_laea[2,2]
###########################################

suppressWarnings( d1 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/50m_MED.shp", sep=""), layer="50m_MED", verbose =F) )
suppressWarnings( d2 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/100m_MED.shp", sep=""), layer="100m_MED", verbose =F) )
suppressWarnings( d3 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/200m_MED.shp", sep=""), layer="200m_MED", verbose =F) )
suppressWarnings( d4 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/500m_MED.shp", sep=""), layer="500m_MED", verbose =F) )
suppressWarnings( d5 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/800m_MED.shp", sep=""), layer="800m_MED", verbose =F) )
suppressWarnings( d6 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/15m_MED.shp", sep=""), layer="15m_MED", verbose =F) )
suppressWarnings( d7 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/25m_MED.shp", sep=""), layer="25m_MED", verbose =F) )
suppressWarnings( d8 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/35m_MED.shp", sep=""), layer="35m_MED", verbose =F) )

if (map_range$depth1 == 50) {depth_1 <- d1}
if (map_range$depth1 == 100) {depth_1 <- d2}
if (map_range$depth1 == 200) {depth_1 <- d3}
if (map_range$depth1 == 500) {depth_1 <- d4}
if (map_range$depth1 == 800) {depth_1 <- d5}
if (map_range$depth1 == 15) {depth_1 <- d6}
if (map_range$depth1 == 25) {depth_1 <- d7}
if (map_range$depth1 == 35) {depth_1 <- d8}

if (map_range$depth2 == 50) {depth_2 <- d1}
if (map_range$depth2 == 100) {depth_2 <- d2}
if (map_range$depth2 == 200) {depth_2 <- d3}
if (map_range$depth2 == 500) {depth_2 <- d4}
if (map_range$depth2 == 800) {depth_2 <- d5}
if (map_range$depth2 == 15) {depth_2 <- d6}
if (map_range$depth2 == 25) {depth_2 <- d7}
if (map_range$depth2 == 35) {depth_2 <- d8}

if (map_range$depth3 == 50) {depth_3 <- d1}
if (map_range$depth3 == 100) {depth_3 <- d2}
if (map_range$depth3 == 200) {depth_3 <- d3}
if (map_range$depth3 == 500) {depth_3 <- d4}
if (map_range$depth3 == 800) {depth_3 <- d5}
if (map_range$depth3 == 15) {depth_3 <- d6}
if (map_range$depth3 == 25) {depth_3 <- d7}
if (map_range$depth3 == 35) {depth_3 <- d8}


###############

if (nrow(metaDB)!=0) {

 loc <- data.frame(id=metaDB$id, COUNTRY=metaDB$COUNTRY, GSA=metaDB$GSA, YEAR=metaDB$YEAR, lon=metaDB$MEAN_LONGITUDE_DEC, lat=metaDB$MEAN_LATITUDE_DEC, N_km2=metaDB$N_km2, kg_km2=metaDB$kg_km2  ) # pivot_r
  # loc0 <- loc[loc$N_km2 == 0, ]
  loc1 <- loc[loc$N_km2 != 0, ]
  br_n <- c(0,as.numeric(summary(loc1$N_km2)[-4]))
  br_kg <-c(0,as.numeric(summary(loc1$kg_km2)[-4]))
  labels_n <- c("0",as.character(round(as.numeric(summary(loc1$N_km2))[-4],3)))
  labels_kg <- c("0",as.character(round(as.numeric(summary(loc1$kg_km2))[-4],3)))

  ###############
  wmap_laea<- spTransform(wmap, CRS("+proj=longlat"))
  countries_laea<-spTransform(countries, CRS("+proj=longlat"))
  depth_1_laea<-spTransform(depth_1, CRS("+proj=longlat"))
  depth_2_laea<-spTransform(depth_2, CRS("+proj=longlat"))
  depth_3_laea<-spTransform(depth_3, CRS("+proj=longlat"))

  coordinates(loc)<-c("lon","lat")
  proj4string(loc) <- CRS("+proj=longlat")
  loc_laea<-spTransform(loc, CRS("+proj=longlat"))

  # if (nrow(loc0)>0) { coordinates(loc0)<-c("lon","lat")
  #    proj4string(loc0) <- CRS("+proj=longlat")
  #    loc_laea0<-spTransform(loc0, CRS("+proj=longlat"))
  # }

  suppressMessages(wmap_laea_df<-fortify(wmap_laea))
  suppressMessages(countries_laea_df<-fortify(countries_laea))
  depth_1_laea_df<-fortify(depth_1_laea)
  depth_2_laea_df<-fortify(depth_2_laea)
  depth_3_laea_df<-fortify(depth_3_laea)

  loc_laea_df<-data.frame(loc_laea)
  loc_laea_df[loc_laea_df$N_km2==0, "colore"] <- "red"
  loc_laea_df[loc_laea_df$N_km2!=0, "colore"] <- "blue"
# loc_laea_df0<-data.frame(loc_laea0)
# colnames(loc_laea_df0) [5] <- "N"

  theme_opts<-list(theme(panel.grid.minor = element_blank(),
                         panel.grid.major = element_blank(),
                         panel.background = element_rect(fill = 'light blue',linetype="solid",color="black"),
                         # plot.background = element_rect(fill="white",
                         #                                size=1,linetype="solid",color="black"),
                         axis.line = element_blank(),
                         axis.text.x = element_blank(),
                         axis.text.y = element_blank(),
                         axis.ticks = element_blank(),
                         axis.title.x = element_blank(),
                         axis.title.y = element_blank(),
                         plot.title = element_text(size=22)))

  buff<-as.numeric(0)
  dep_text_N <-expression(paste("Abundance by haul ", (n/km^2), sep=" "))  # ," - ",depth_range[1],"-",depth_range[2]," m"
  dep_text_kg <-expression(paste("Biomass by haul ", (kg/km^2), sep=" "))  # ," - ",depth_range[1],"-",depth_range[2]," m"

  suppressMessages(

    ggplot() +
      coord_map(projection="mercator",xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
      # coord_cartesian(xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
      # coord_cartesian(xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
      geom_polygon(data=wmap_laea_df, aes(long,lat,group=group), fill="light grey")+
      geom_path(data=countries_laea_df, aes(long,lat, group=group), color="black",size=0.1) +
      geom_path(data=depth_1_laea_df, aes(long,lat, group=group), color="#C0C0C0",size=0.4) +
      geom_path(data=depth_2_laea_df, aes(long,lat, group=group), color="#A9A9A9",size=0.4) +
      geom_path(data=depth_3_laea_df, aes(long,lat, group=group), color="#808080",size=0.4) +
      geom_point(data=loc_laea_df, aes(lon, lat, group=NA,fill=NA,size=N_km2),shape=21,
                 colour="black",fill=loc_laea_df$colore,alpha=I(3/10)) +
      scale_size(range=c(1,14), breaks =br_n, labels = labels_n, guide = "legend",labs(size="n/km^2")) +
      # theme(aspect.ratio=map_ratio*1.5)+
      ggtitle(dep_text_N)+
      theme_opts

  )


  ggsave(paste(wd, "/output/",sspp,"_GSA",GSA,"-Abundance_by_haul.jpg", sep=""),
         width = 20, height = 20, units ="cm", dpi = 300)

  suppressMessages(

    ggplot() +
      coord_map(projection="mercator",xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
      # coord_cartesian(xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
      # coord_cartesian(xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
      geom_polygon(data=wmap_laea_df, aes(long,lat,group=group), fill="light grey")+
      geom_path(data=countries_laea_df, aes(long,lat, group=group), color="black",size=0.1) +
      geom_path(data=depth_1_laea_df, aes(long,lat, group=group), color="#C0C0C0",size=0.4) +
      geom_path(data=depth_2_laea_df, aes(long,lat, group=group), color="#A9A9A9",size=0.4) +
      geom_path(data=depth_3_laea_df, aes(long,lat, group=group), color="#808080",size=0.4) +
      geom_point(data=loc_laea_df, aes(lon, lat, group=NA,fill=NA,size=kg_km2),shape=21,
                 colour="black",fill=loc_laea_df$colore,alpha=I(3/10)) +
      scale_size(range=c(1,14), breaks =br_kg, labels = labels_kg, guide = "legend",labs(size="kg/km^2")) +
      # theme(aspect.ratio=map_ratio*1.5)+
      ggtitle(dep_text_kg)+
      theme_opts

  )

  ggsave(paste(wd, "/output/",sspp,"_GSA",GSA,"-Biomass_by_haul.jpg", sep=""),
         width = 20, height = 20, units ="cm", dpi = 300)


} else {
  cat("Not enough data to be plotted\n")
  cat("Bubble plots - indices  by haul skipped\n\n")
}

##################
##################
##################
