wmap <- readOGR(dsn=paste(wd,"/scripts/utilities/continent/ne_10m_land.shp", sep=""), layer="ne_10m_land", verbose =F)
countries <- readOGR(paste(wd,"/scripts/utilities/continent/ne_10m_admin_0_countries.shp", sep=""), layer="ne_10m_admin_0_countries", verbose =F)
merge_TATB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
# GENERE <- as.character(unique(merge_TATB$GENUS)[unique(merge_TATB$GENUS) != -1])
# SPECIE <- as.character(unique(merge_TATB$SPECIES)[unique(merge_TATB$SPECIES) != -1])
sspp <- paste(GENERE,SPECIE, sep="")
GSA <- unique(merge_TATB$GSA)
species <- sspp

# #### Handmade selection of map limits ####
# map_coord <- area.coord()
# map_lim  <- map_coord[[1]]
# map_ratio <- map_coord[[2]]
# limits <- data.frame(matrix(NA,ncol=2, nrow=2))
# colnames(limits)<- c("X","Y")
# limits[1,1]<- map_lim[1]
# limits[1,2]<- map_lim[3]
# limits[2,1]<- map_lim[2]
# limits[2,2]<- map_lim[4]
# coordinates(limits) <- ~ X+Y
# proj4string(limits) <- CRS("+proj=longlat")
# lim_laea<-as.data.frame(spTransform(limits, CRS("+proj=laea")))
# xmin<-lim_laea[1,1]
# xmax<-lim_laea[2,1]
# ymin<-lim_laea[1,2]
# ymax<-lim_laea[2,2]
# ###########################################

metaDB <- merge_TATB # read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]

if (nrow(map_range)==0) {
  SR_analysis <-tk_messageBox(type="ok",message="No map range available. Please, insert coordinates' limits information.")
  map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
  map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]
  if (nrow(map_range)==0) {
    stop("No map range available. Please, insert information about coordinates limits")
  }
} else {
  if (nrow(map_range)>1) {
    if (check_country=="Y") {
      x1 <- min(map_range$xmin)
      x2 <- max(map_range$xmax)
      y1 <- min(map_range$ymin)
      y2 <- max(map_range$ymax)
      map_range <- map_range[1,]
      map_range[1,3] <- x1
      map_range[1,4] <- x2
      map_range[1,5] <- y1
      map_range[1,6] <- y2
    }
  }
}

#### selection of map limits by file ####
map_lim  <- as.numeric(map_range[,3:6])
lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
map_ratio <- ly/lx

limits <- data.frame(matrix(NA,ncol=2, nrow=2))
colnames(limits)<- c("X","Y")
limits[1,1]<- map_lim[1]
limits[1,2]<- map_lim[3]
limits[2,1]<- map_lim[2]
limits[2,2]<- map_lim[4]
coordinates(limits) <- ~ X+Y
proj4string(limits) <- CRS("+proj=longlat")
lim_laea<-as.data.frame(spTransform(limits, CRS("+proj=longlat")))
xmin<-lim_laea[1,1]
xmax<-lim_laea[2,1]
ymin<-lim_laea[1,2]
ymax<-lim_laea[2,2]
###########################################

d1 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/50m_MED.shp", sep=""), layer="50m_MED", verbose =F)
d2 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/100m_MED.shp", sep=""), layer="100m_MED", verbose =F)
d3 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/200m_MED.shp", sep=""), layer="200m_MED", verbose =F)
d4 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/500m_MED.shp", sep=""), layer="500m_MED", verbose =F)
d5 <- readOGR(paste(wd,"/scripts/utilities/bathymetry/800m_MED.shp", sep=""), layer="800m_MED", verbose =F)

if (map_range$depth1 == 50) {depth_1 <- d1}
if (map_range$depth1 == 100) {depth_1 <- d2}
if (map_range$depth1 == 200) {depth_1 <- d3}
if (map_range$depth1 == 500) {depth_1 <- d4}
if (map_range$depth1 == 800) {depth_1 <- d5}

if (map_range$depth2 == 50) {depth_2 <- d1}
if (map_range$depth2 == 100) {depth_2 <- d2}
if (map_range$depth2 == 200) {depth_2 <- d3}
if (map_range$depth2 == 500) {depth_2 <- d4}
if (map_range$depth2 == 800) {depth_2 <- d5}

if (map_range$depth3 == 50) {depth_3 <- d1}
if (map_range$depth3 == 100) {depth_3 <- d2}
if (map_range$depth3 == 200) {depth_3 <- d3}
if (map_range$depth3 == 500) {depth_3 <- d4}
if (map_range$depth3 == 800) {depth_3 <- d5}

###############


ddd <- NA
ddd <- merge_TATB
# pivot_r <- aggregate(as.numeric(as.character(ddd_r$N_km2)), by=list(ddd_r$id, ddd_r$MEAN_LONGITUDE_DEC, ddd_r$MEAN_LATITUDE_DEC), sum)
# colnames(pivot_r) <- c("id", "lon", "lat", "indices")
loc <- data.frame(id=ddd$id, Haul = ddd$HAUL_NUMBER, Year = as.factor(ddd$YEAR), lon=ddd$MEAN_LONGITUDE_DEC, lat=ddd$MEAN_LATITUDE_DEC)

###############
wmap_laea<- spTransform(wmap, CRS("+proj=longlat"))
countries_laea<-spTransform(countries, CRS("+proj=longlat"))
depth_1_laea<-spTransform(depth_1, CRS("+proj=longlat"))
depth_2_laea<-spTransform(depth_2, CRS("+proj=longlat"))
depth_3_laea<-spTransform(depth_3, CRS("+proj=longlat"))

coordinates(loc)<-c("lon","lat")
proj4string(loc) <- CRS("+proj=longlat")
loc_laea<-spTransform(loc, CRS("+proj=longlat"))

suppressMessages(wmap_laea_df<-fortify(wmap_laea))
suppressMessages(countries_laea_df<-fortify(countries_laea))
depth_1_laea_df<-fortify(depth_1_laea)
depth_2_laea_df<-fortify(depth_2_laea)
depth_3_laea_df<-fortify(depth_3_laea)

loc_laea_df<-data.frame(loc_laea)

theme_opts<-list(theme(panel.grid.minor = element_blank(),
                       panel.grid.major = element_blank(),
                       panel.background = element_rect(fill = 'light blue',linetype="solid",color="black"),
                       plot.background = element_rect(fill="white",
                                                      size=1,linetype="solid",color="black"),
                       axis.line = element_blank(),
                       axis.text.x = element_blank(),
                       axis.text.y = element_blank(),
                       axis.ticks = element_blank(),
                       axis.title.x = element_blank(),
                       axis.title.y = element_blank(),
                       plot.title = element_text(size=22)))

# xmin<-min(loc_laea_df$lon)
# xmax<-max(loc_laea_df$lon)
# ymin<-min(loc_laea_df$lat)
# ymax<-max(loc_laea_df$lat)
buff<-0
dep_text <-"Hauls position"
ggplot() +
  geom_polygon(data=wmap_laea_df, aes(long,lat,group=group), fill="light grey")+
  geom_path(data=countries_laea_df, aes(long,lat, group=group), color="black",size=0.1) +
  geom_path(data=depth_1_laea_df, aes(long,lat, group=group), color="#C0C0C0",size=0.4) +
  geom_path(data=depth_2_laea_df, aes(long,lat, group=group), color="#A9A9A9",size=0.4) +
  geom_path(data=depth_3_laea_df, aes(long,lat, group=group), color="#808080",size=0.4) +
  # geom_point(data=loc_laea_df, aes(lon, lat,color=Year, fill=Year),shape=21,color="black",alpha=I(4/10)) +
  geom_text(data=loc_laea_df, aes(lon, lat, label=Haul)) +
  geom_point(data=loc_laea_df, aes(lon, lat,color=Year, fill=Year)) +
  coord_map(projection="mercator",xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
  # scale_size(range=c(1,14), breaks =br, labels = labels, guide = "legend",labs(size="n/km^2")) +
  # coord_cartesian(xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
  # theme(aspect.ratio=map_ratio*1.5)+
  ggtitle(dep_text)+
  theme_opts








# colnames(loc_laea_df)[3] <- "Survey"
# ggplot() +
#   geom_polygon(data=wmap_laea_df, aes(long,lat,group=group), fill="light grey")+
#   geom_path(data=countries_laea_df, aes(long,lat, group=group), color="black",size=0.1) +
#   geom_path(data=depth_1_laea_df, aes(long,lat, group=group), color="#C0C0C0",size=0.4) +
#   geom_path(data=depth_2_laea_df, aes(long,lat, group=group), color="#A9A9A9",size=0.4) +
#   geom_path(data=depth_3_laea_df, aes(long,lat, group=group), color="#808080",size=0.4) +
#   # geom_point(data=loc_laea_df, aes(lon, lat,color=Year, fill=Year),shape=21,color="black",alpha=I(4/10)) +
#   geom_text(data=loc_laea_df, aes(lon, lat, label=Haul)) +
#   geom_point(data=loc_laea_df, aes(lon, lat,color=Survey, fill=Survey)) +
#   # scale_size(range=c(1,14), breaks =br, labels = labels, guide = "legend",labs(size="n/km^2")) +
#   coord_cartesian(xlim = c((xmin-buff),(xmax+buff)), ylim = c((ymin-buff),(ymax+buff))) +
#   theme(aspect.ratio=map_ratio*1.5)+
#   theme_opts
# +
#   scale_color_manual(name = "depth (m)", values = c("200" = "#C0C0C0", "500 m" = "#A9A9A9", "800 m" = "#808080"))

ggsave(paste(wd, "/output/",sspp,"_GSA",GSA," -Hauls position.jpg", sep=""),
       width = 20, height = 20, units ="cm", dpi = 300)

cat("Bubble plot of Hauls position correctly saved \n")

