merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

dependent <- "abundance" 
dep_text <-expression(paste(Abundance, (n/km^2), sep=" "))
varcol <- which(colnames(merge_TATC)=="N_km2")
col_response <- which(colnames(merge_TATC)=="N_km2")


df_cutoff <- read.table(paste(wd, "/input/maturity_sizes.csv", sep=""), sep=";", header=T)
threshold <- df_cutoff[df_cutoff$species == sspp & df_cutoff$GSA == GSA, "threshold_recruits" ]

GENERE <- as.character(unique(merge_TATC$GENUS)[unique(merge_TATC$GENUS) != -1])
SPECIE <- as.character(unique(merge_TATC$SPECIES)[unique(merge_TATC$SPECIES) != -1])
sspp <- paste(GENERE,SPECIE, sep="")
GSA <- unique(merge_TATC$GSA)
species <- sspp
# plotting species' depth range information

merge_TATC$n_raised <- merge_TATC$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * merge_TATC$RAISING_FACTOR
ddd <- merge_TATC[merge_TATC$LENGTH_CLASS <= threshold  ,] 

ddd_n <- aggregate(ddd$n_raised, by=list(ddd$id), sum) # [,1])
colnames(ddd_n) <- c("id","sum_N")
ddd_nkm2 <-  aggregate(ddd$N_km2, by=list(ddd$id), sum)
colnames(ddd_nkm2) <- c("id","sum_nkm2")
merge_N <- merge(ddd_n, ddd_nkm2, by.x="id")
ddd <- merge(merge_TATB[,c(1,3,4,6,23,24,32,34,35,36)], merge_N, by.y="id",all.x =T)
# ddd <- ddd[ddd$MEAN_DEPTH >=depth_range[1] &ddd$MEAN_DEPTH < depth_range[2],]

for (i in 1:length(ddd$sum_N)){
  if (is.na(ddd[i,"sum_N" ])) {ddd[i,"sum_N" ] <- 0} else {ddd[i,"sum_N" ] <- ddd[i,"sum_N" ]}
  if (is.na(ddd[i,"sum_nkm2" ])) {ddd[i,"sum_nkm2" ] <- 0} else {ddd[i,"sum_nkm2" ] <- ddd[i,"sum_nkm2" ]}
}

main <- paste(sspp,"_GSA",GSA,"_(abundance of recruits)-Simple_Random_Sampling_", sep="")
write.table(ddd, paste(wd,"/output/",main,"_Hauls.csv", sep=""), sep=";", row.names = F)

year_range <- data.frame(year = sort(unique(merge_TATC$YEAR)))

res_table_cala2 <- data.frame(year=sort(unique(ddd$YEAR)))
res_table_cala2$abundance <- NA
res_table_cala2$sd <- NA
res_table_cala2$CV <- NA
res_table_cala2$incCV <- NA
res_table_cala2$positive_hauls_perc <- NA

i=1
for(i in 1:length(res_table_cala2[,1])) {
  
  data2 <- ddd[ddd$YEAR == res_table_cala2[i,1] , ]
  if (length(data2[data2$sum_N >0 ,"sum_N"])>=1){
    
    res_table_cala2[i,2] <- mean(data2$sum_nkm2)
    res_table_cala2[i,3] <- sd(data2$sum_nkm2)
    res_table_cala2[i,4] <- res_table_cala2[i,3]/res_table_cala2[i,2]
    res_table_cala2[i,5] <- 1/res_table_cala2[i,4]
  } else { 
    res_table_cala2[i,2] <- 0 
    res_table_cala2[i,3] <- NA
    res_table_cala2[i,4] <- NA
    res_table_cala2[i,5] <- NA
  }
  
  positive_hauls[i] <- length(merge_TATB[merge_TATB$TOTAL_NUMBER_IN_THE_HAUL>0 & merge_TATB$YEAR == res_table_cala2[i,1],"TOTAL_NUMBER_IN_THE_HAUL"])
  total_hauls[i] <- length(merge_TATB[merge_TATB$YEAR == res_table_cala2[i,1],"HAUL_NUMBER"]) 
  
  res_table_cala2[i,6] <- positive_hauls[i]/total_hauls[i]*100
  
}

timeseries <- res_table_cala2

# plot timeseries of mean recruits indices   
    main <- paste(sspp,"_GSA",GSA,"_(abundance of recruits)-Simple_Random_Sampling_", sep="")
    main.lab <- paste(sspp," GSA",GSA," (abundance of recruits)-SRS ", sep="")
    max_index <- max(timeseries[,2]) + max(timeseries[,3])*1.2
    write.table(timeseries, paste(wd,"/output/",main,"_Timeseries.csv", sep=""), sep=";", row.names = F)

    tiff(paste(wd,"/output/",main,"_Timeseries.tiff",sep=""), res = 300, width = 8, height = 7, units = 'in', compression = 'lzw', pointsize = 1/300)
    par(mfrow=c(1,1),oma=c(1,1,1,1), mgp=c(2, 1,0)) 
    plot(timeseries[,1],  timeseries[,2], type="b", col="black", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab=dep_text, main=main.lab) # ylim=c(0,max_index*1.2)
    lines(timeseries[,1], (timeseries[,2]-1.96*timeseries[,3]), type="l",lty=2, col="red" )
    lines(timeseries[,1], (timeseries[,2]+1.96*timeseries[,3]), type="l",lty=2, col="red" )
    legend("topright", c("time series", "CI"), lty=c(1,2), pch=c(16, NA), col=c("black","red"))
    dev.off()