quant <- function(weighted,qlin=0.95){
  #fonction pour calculer un quantile d'un vecteur pondere  (R-Sufi software)
  #et les elements pour calcul de la variance (Cf Kendall & Stuart 1977 vol 1 p. 252)
  #les classes de la variable sont dans la premi?re colonne
  #les poids dans la deuxieme
  #fonction prevue pour trouver de grands quantiles
  #donc travaille e reculons
  #hypothese de distribution uniforme e l'interieur des classes
  #Auteur M.J. Rochet d?cembre 2004
  weighted <- data.frame(weighted)            # added
  weighted <- weighted[weighted$X2 != 0 , ]   # added
  w <- aggregate(weighted[,2],list(G=weighted[,1]),FUN=sum,na.rm=T)
  x <- as.numeric(as.character(w$G))
  w <- w$x
  if(qlin<0.5) {
    x <- -x
    ql <- 1-qlin
  } else {
    ql <- qlin
  }
  tot <- sum(w)
  frac <- tot*(1-ql)
  w <- w[order(-x)]
  x <- x[order(-x)]
  somme <- w[1]
  i <- 2
  while(somme < frac){
    somme <- somme + w[i]
    i <- i+1
  }
  lq <- round(x[i] + (x[i-1]-x[i])/w[i-1]*(somme-frac),1)
  f1 <- w[i]/tot
  vlq <- ql*(1-ql)/(f1^2)/tot
  SD <- sqrt(vlq)
  cv <- sqrt(vlq)/ifelse(qlin<0.5,-lq,lq)
  c(quantile=ifelse(qlin<0.5,-lq,lq),SD=SD,cv=cv)
}

Dati=read.table(paste(wd,"/output/",sspp,"_GSA",GSA,"_LFD_(Combined)_RPS.csv", sep=""), sep=";", header=T)

col_names <- colnames(Dati)
col_years <- col_names[-1]
col_years <- as.numeric(substr(col_years,2,5))
years_tab <- col_years

table=data.frame(matrix(NA,nrow=6,ncol=(ncol(Dati)-1)))
i=2
for (i in c(2:ncol(Dati))){
Dati_temp=cbind(Dati[,1],Dati[,i])
# table [1,i] = round(quant(Dati_temp, 0.25)[1],2)
# table [2,i] = round(min(Dati_temp[Dati_temp[,2]>0,1]),2)
# table [3,i] = round(quant(Dati_temp, 0.99)[1],2)
# table [4,i] = round(quant(Dati_temp, 0.5)[1],2)
# table [5,i] = round(quant(Dati_temp, 0.75)[1],2)
# table [6,i] = round(sum(Dati_temp[,1]*Dati_temp[,2])/sum(Dati_temp[,2]),2)
# table [7,i] = round(quant(Dati_temp, 0.95)[1],2)
# table [8,i] = round(sqrt(sum(Dati_temp[,2]*(Dati_temp[,1]-table[6,i])^2)/sum(Dati_temp[,2])),2)

table [1,i] = round(quant(Dati_temp, 0.50)[1],4)
table [2,i] = round(quant(Dati_temp, 0.50)[2],4) #round(sqrt(sum(Dati_temp[,2]*(Dati_temp[,1]-table[6,i])^2)/sum(Dati_temp[,2])),2)
table [3,i] = round(quant(Dati_temp, 0.50)[3],4)
table [4,i] = round(quant(Dati_temp, 0.95)[1],4)
table [5,i] = round(quant(Dati_temp, 0.95)[2],2)
table [6,i] = round(quant(Dati_temp, 0.95)[3],4)
Dati_temp[,] = 0
}
# table[,1]=c("I quartile","min","max (99%)","LT Median","III quartile","Mean","95th percentile","s.dev")
table[,1]=c("50th perc.","SD 50th perc.","CV 50th perc.","95th perc.","SD 95th perc.","CV 95th perc.")
colnames(table)=c("Indices", years_tab)

write.table(table,paste(wd, "/output/",sspp,"_GSA",GSA,"_L50_L95_RPS.csv", sep=""),sep=";",row.names=F)



