merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Penalized_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
indices.strata <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance_by_stratum)-RPS_",depth_range[1],"-",depth_range[2]," m.csv", sep=""), sep=";", header=T)

class_code <- unique(merge_TATC[merge_TATC$GENUS != -1, "LENGTH_CLASSES_CODE"])
if (class_code == "m") {LC <- 1} else {
  if (class_code == "0") {LC <- 5} else {
    if (class_code == "1") {LC <- 10}
  }
}


ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1,]

if (nrow(ddd) != 0) {

ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
years <- sort(unique(ddd$YEAR))

L_classes <- seq(lmin, lmax, LC)
df_n_LC <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
colnames(df_n_LC) <- c("Classe", years)
df_n_LC[,1] <- L_classes
L_classes <- data.frame(LC = L_classes)
i=1
 for (i in 1:length(years)) {
   dd <- ddd[ddd$YEAR ==years[i] & ddd$MEAN_DEPTH >= depth_range[1] & ddd$MEAN_DEPTH < depth_range[2],]
   check_sex <- length(dd[ , 1])
   if( check_sex != 0 ){
   n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
   colnames(n_LC) <- c("LC", "n")
   df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
   ntot <- sum(df_temp[!is.na(df_temp$n), 2])
   peso_LC <- df_temp/ntot
   ind_year <- indices[indices$year == years[i], 2]
   ind_LC <- peso_LC * ind_year
   for (n in 1:length(ind_LC$LC)) {
     if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
   }
   df_n_LC[, i+1] <- ind_LC[,2]
   } else {
     min_LC <- lmin
     n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
     colnames(n_LC) <- c("LC", "n")
     n_LC[1,1] <- min_LC
     n_LC[1,2] <- 0
     df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
     ntot <- sum(df_temp[!is.na(df_temp$n), 2])
     peso_LC <- df_temp/ntot
     ind_year <- indices[indices$year == years[i], 2]
     ind_LC <- peso_LC * ind_year
     for (n in 1:length(ind_LC$LC)) {
       if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
     }
     df_n_LC[, i+1] <- ind_LC[,2]
   }
 }

write.table(df_n_LC,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Combined)_RPS.csv", sep=""),sep=";",row.names=F)
i=1

min_lc <-min(merge_TATC$LENGTH_CLASS)
max_lc <-max(merge_TATC$LENGTH_CLASS)
max_freq <- max(df_n_LC[,2:length(df_n_LC)])*1.2

for (i in 1:(length(df_n_LC)-1)){
df_n_LC_temp <- df_n_LC[,c(1,(i+1))]
df_n_LC_temp[,3] <- as.numeric(colnames(df_n_LC)[i+1])
colnames(df_n_LC_temp) <- c("LC", "frequency", "year")

if (i == 1){ df_n_LC_gg <- df_n_LC_temp } else {
  df_n_LC_gg <- rbind(df_n_LC_gg, df_n_LC_temp)
}
}
df_n_LC_gg$year <- factor(df_n_LC_gg$year)
ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
  geom_line() +     # Set linetype by sex       # Use larger points, fill with white
  xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
  ggtitle("LFD (Combined)") +     # Set title
  xlim(min_lc, max_lc) +
  ylim(0,max_freq) +
  theme_bw()
ggsave(paste(wd,"/output/LFD_(Combined)_",sspp,"_GSA",GSA,"_RPS.jpg", sep=""),width=7, height=5)

} else {
  cat("Not enough data for LFD estimation\n")
}


#----------------
# LFD per stratum
#----------------
# strata definition

c.tab <- depth[!is.na(depth$strata), 'strata']+1
ncol.tab <- length(depth[!is.na(depth$strata), 'strata'])
n.tab <- length(depth[!is.na(depth$strata), 'strata'])
TABmean <- data.frame(matrix(ncol=(1+ncol.tab*2), nrow=length(years)))
colnames(TABmean) <- c("year", paste("mean_length",depth[!is.na(depth$strata), 'strata'], sep="_"), paste("SD",depth[!is.na(depth$strata), 'strata'], sep="_"))
TABmean$year=years
ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1,  ]

if (nrow(ddd) != 0) {

  ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
  lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
  lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
  years <- sort(unique(ddd$YEAR))

  L_classes <- seq(lmin, lmax, LC)
  df_n_LC <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
  colnames(df_n_LC) <- c("Classe", years)
  df_n_LC[,1] <- L_classes
  L_classes <- data.frame(LC = L_classes)

  lfd.list <- data.frame(matrix(NA, nrow= 0, ncol=length(years)+2))
  colnames(lfd.list) <- c("Classe", years,"stratum")

  s=4
  for (s in strata_range) {

    str.depth <- as.numeric(depth[!is.na(depth$strata) & depth$strata==s,c(2,3)])
    data <- ddd[ddd$MEAN_DEPTH >= str.depth[1] & ddd$MEAN_DEPTH < str.depth[2], ]


    i=2
    for (i in 1:length(years)) {
      dd <- data[data$YEAR ==years[i] & data$MEAN_DEPTH >= str.depth[1] & data$MEAN_DEPTH < str.depth[2],]
      check_sex <- length(dd[ , 1])
      if( check_sex != 0 ){
        n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
        colnames(n_LC) <- c("LC", "n")
        df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
        ntot <- sum(df_temp[!is.na(df_temp$n), 2])
        peso_LC <- df_temp/ntot
        peso_LC$LC <- L_classes
        ind_year <- indices.strata[indices$year==years[i], s+1]
        ind_LC <- peso_LC * ind_year
        for (n in 1:length(ind_LC$LC)) {
          if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
        }
        df_n_LC[, i+1] <- ind_LC[,2]

        ###############################################################################
        df.temp <- df_n_LC[,c(1,i+1)]
        df.temp$xp <- df.temp[,1] * df.temp[,2]
        mean_length <- sum(df.temp$xp, na.rm=TRUE)/sum(df.temp[,2], na.rm=TRUE)
        weights <- sum(df.temp[,2], na.rm=TRUE)
        df.temp$wsq <- df.temp[,2]*(df.temp[,1] - mean_length)^2
        sum.wsq <- sum(df.temp$wsq, na.rm=TRUE)
        sd_length <- sqrt(sum.wsq/weights)

        TABmean[TABmean$year==years[i], s+1] <- mean_length
        TABmean[TABmean$year==years[i], s+1+ncol.tab] <- sd_length
        ###############################################################################

      } else {
        min_LC <- lmin
        n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
        colnames(n_LC) <- c("LC", "n")
        n_LC[1,1] <- min_LC
        n_LC[1,2] <- 0
        df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
        ntot <- sum(df_temp[!is.na(df_temp$n), 2])
        peso_LC <- df_temp/ntot
        ind_year <- indices[indices$year == years[i], 2]
        ind_LC <- peso_LC * ind_year
        for (n in 1:length(ind_LC$LC)) {
          if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
        }
        df_n_LC[, i+1] <- ind_LC[,2]
      }

    }

    df_n_LC$stratum <- s
    if (s == strata_range[1]){ lfd.list <- df_n_LC } else {
      lfd.list <- rbind(lfd.list, df_n_LC)
    }
  } # chiusura ciclo strata_range

  ncol.tab <- ncol(lfd.list)
  names.cols <- c(colnames(lfd.list)[1], colnames(lfd.list)[ncol.tab], colnames(lfd.list)[2:(ncol.tab-1)])
  lfd.list <- data.frame(lfd.list[,1], lfd.list[, ncol.tab], lfd.list[, c(2:(ncol.tab-1))])
  colnames(lfd.list) <- names.cols
  write.table(lfd.list,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Combined_by_stratum)_RPS.csv", sep=""),sep=";",row.names=F)

  sel.strata1 <- c(1,depth[(depth$bul), "strata"] + 1)
  sel.strata2 <- c(1, depth[(depth$bul), "strata"] + 1 + length(cols.strata))
  TABmeanCV <- TABmean
  colnames(TABmeanCV) <- c("year", paste("mean_length",depth[!is.na(depth$strata), 'strata'], sep="_"), paste("CV",depth[!is.na(depth$strata), 'strata'], sep="_"))
  colCV <- depth[(depth$bul), "strata"] + 1
  r=1
  for (r in 1:nrow(TABmeanCV)) {
    c=5
    for (c in colCV) {
      if (!is.na(TABmeanCV[r,c]>=0) & TABmeanCV[r,c]>=0 & TABmeanCV[r,c+length(cols.strata)]>0) {
        TABmeanCV[r,c+length(cols.strata)] <- (TABmeanCV[r,c+length(cols.strata)] / TABmeanCV[r,c])
      } else {
        TABmeanCV[r,c+length(cols.strata)] <- NA
      }
    }
  }

  TABmean <- cbind(TABmean, TABmeanCV[, c.tab+n.tab])
  write.table(TABmean,paste(wd, "/output/",sspp,"_GSA",GSA,"_MEAN_LENGTH_(by_stratum)_RPS.csv", sep=""),sep=";",row.names=F)


  ### plot Mean Length
  {
    sel.strata1 <- c(1,depth[(depth$bul), "strata"] + 1)
    sel.strata2 <- c(1, depth[(depth$bul), "strata"] + 1 + length(cols.strata))
    tab.ind <- TABmean[, sel.strata1]
    tab.sd <- TABmean[, sel.strata2]
    df.plot1 <- melt(tab.ind, id.vars = 1)
    df.plot2 <- melt(tab.sd, id.vars = 1)
    var1 <-  as.data.frame(do.call(rbind, str_split(as.character(df.plot1$variable),"_")))[,c(2,3)]; var1[,1] <- "mean_length"; colnames(var1) <- c("var", "strata")
    var2 <-  as.data.frame(do.call(rbind, str_split(as.character(df.plot2$variable),"_"))); colnames(var2) <- c("var", "strata")
    df.plot1 <- cbind(df.plot1,var1)
    df.plot2 <- cbind(df.plot2,var2)
    df.plot1 <- data.frame(df.plot1, sd=df.plot2$value)
    main <- paste(sspp,"_GSA",GSA,"_(MEAN_LENGTH_by_stratum)-RPS_",depth_range[1],"-",depth_range[2], " m", sep="")
    main.lab <- paste(sspp," GSA",GSA," (MEAN LENGTH by stratum)-RPS ",depth_range[1],"-",depth_range[2], " m", sep="")
    dep_text <-expression(paste("Mean length (mm) ", sep=" "))

    if (length(years)>1){
      ggplot(data=df.plot1, aes(x=year, y=value, group=strata, colour=strata)) +
        geom_line() +
        geom_point() +
        xlab("year") +
        ylab(dep_text) +
        ggtitle(main.lab) +
        theme_bw() 
        ggsave(paste(wd,"/output/",main,"_Timeseries.jpg",sep=""), dpi=300 , width=6, height=5) #
    } else {
      ggplot(data=df.plot1, aes(x=year, y=value, group=strata, colour=strata)) +
        geom_point() +
        xlab("year") +
        ylab(dep_text) +
        ggtitle(main.lab) +
        theme_bw() 
        ggsave(paste(wd,"/output/",main,"_Timeseries.jpg",sep=""), dpi=300 , width=6, height=5)
    }
  }

  min_lc <-lmin
  max_lc <-lmax
  max_freq <- max(lfd.list[,3:length(lfd.list)])*1.2

  df_n_LC_gg <- melt(data=lfd.list, id.vars = c(1,2))
  colnames(df_n_LC_gg) <- c("LC","stratum","year","frequency")

  df_n_LC_gg$year <- factor(df_n_LC_gg$year)


  if (length(strata_range) <=2) {
    rows.graph = 1
    if (length(strata_range)==1) {
      height = 5
      width = 5
      cols.graph = 1
    } else {
      height = 6
      cols.graph =2
      width = 10
    }
  } else if (length(strata_range) %in% c(3,4)) {
    height = 7
    width = 7
    cols.graph =2
    rows.graph = 2
  } else if (length(strata_range) %in% c(5,6)) {
    height = 7
    width = 10
    cols.graph =3
    rows.graph = 2
  }

  ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
    geom_line() +     # Set linetype by sex       # Use larger points, fill with white
    xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
    ggtitle("LFD (Combined by stratum)") +     # Set title
    xlim(min_lc, max_lc) +
    ylim(0,max_freq) +
    facet_wrap(~ stratum, ncol=cols.graph) +
    theme_bw()

  ggsave(paste(wd,"/output/LFD_(Combined_by_stratum)_",sspp,"_GSA",GSA,"_RPS.jpg", sep=""), dpi=300 , width=width, height=height) #

} else {
  cat("Not enough data for estimation of LFD by stratum\n")
}


#------------
# FEMALES
#------------

merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-FEMALES-Random_Penalized_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
# indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)

ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1 & merge_TATC$SEX == "F",]

if (nrow(ddd) != 0) {

ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
years <- sort(unique(ddd$YEAR))

L_classes <- seq(lmin, lmax, LC)
df_n_LC_M <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
colnames(df_n_LC_M) <- c("Classe", years)
df_n_LC_M[,1] <- L_classes
L_classes <- data.frame(LC = L_classes)
i=1
for (i in 1:length(years)) {
  dd <- ddd[ddd$YEAR ==years[i] & ddd$MEAN_DEPTH >= depth_range[1] & ddd$MEAN_DEPTH < depth_range[2],]
  check_sex <- length(dd[ , 1])
  if( check_sex != 0 ){
  n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
  colnames(n_LC) <- c("LC", "n")
  df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
  ntot <- sum(df_temp[!is.na(df_temp$n), 2])
  peso_LC <- df_temp/ntot
  ind_year <- indices[indices$year == years[i], 2]
  ind_LC <- peso_LC * ind_year
  for (n in 1:length(ind_LC$LC)) {
    if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
  }
  df_n_LC_M[, i+1] <- ind_LC[,2]
  } else {
    min_LC <- lmin
    n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
    colnames(n_LC) <- c("LC", "n")
    n_LC[1,1] <- min_LC
    n_LC[1,2] <- 0
    df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
    ntot <- sum(df_temp[!is.na(df_temp$n), 2])
    peso_LC <- df_temp/ntot
    ind_year <- indices[indices$year == years[i], 2]
    ind_LC <- peso_LC * ind_year
    for (n in 1:length(ind_LC$LC)) {
      if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
    }
    df_n_LC_M[, i+1] <- ind_LC[,2]
  }
}

write.table(df_n_LC_M,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Females)_RPS.csv", sep=""),sep=";",row.names=F)

for (i in 1:(length(df_n_LC_M)-1)){
  df_n_LC_temp <- df_n_LC_M[,c(1,(i+1))]
  df_n_LC_temp[,3] <- as.numeric(colnames(df_n_LC_M)[i+1])
  colnames(df_n_LC_temp) <- c("LC", "frequency", "year")

  if (i == 1){ df_n_LC_gg <- df_n_LC_temp } else {
    df_n_LC_gg <- rbind(df_n_LC_gg, df_n_LC_temp)
  }
}
df_n_LC_gg$year <- factor(df_n_LC_gg$year)

max_freq <- max(df_n_LC_M[,2:length(df_n_LC_M)])*1.2

ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
  geom_line() +     # Set linetype by sex       # Use larger points, fill with white
  xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
  ggtitle("LFD (Females)") +     # Set title
  xlim(min_lc, max_lc) +
  ylim(0,max_freq) +
  theme_bw()
ggsave(paste(wd,"/output/LFD_(Females)_",sspp,"_GSA",GSA,"_RPS.jpg", sep=""),width=7, height=5)

} else {
  cat("Not enough data for LFD estimation of Females\n")
}
#------------
# MALES
#------------

merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-MALES-Random_Penalized_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
# indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)

ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1 & merge_TATC$SEX == "M",]

if (nrow(ddd) != 0) {

ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
years <- sort(unique(ddd$YEAR))

L_classes <- seq(lmin, lmax, LC)
df_n_LC_M <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
colnames(df_n_LC_M) <- c("Classe", years)
df_n_LC_M[,1] <- L_classes
L_classes <- data.frame(LC = L_classes)
i=1
for (i in 1:length(years)) {
  dd <- ddd[ddd$YEAR ==years[i] & ddd$MEAN_DEPTH >= depth_range[1] & ddd$MEAN_DEPTH < depth_range[2],]
  check_sex <- length(dd[ , 1])
  if( check_sex != 0 ){
  n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
  colnames(n_LC) <- c("LC", "n")
  df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
  ntot <- sum(df_temp[!is.na(df_temp$n), 2])
  peso_LC <- df_temp/ntot
  ind_year <- indices[indices$year == years[i], 2]
  ind_LC <- peso_LC * ind_year
  for (n in 1:length(ind_LC$LC)) {
    if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
  }
  df_n_LC_M[, i+1] <- ind_LC[,2]
  } else {
    min_LC <- lmin
    n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
    colnames(n_LC) <- c("LC", "n")
    n_LC[1,1] <- min_LC
    n_LC[1,2] <- 0
    df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
    ntot <- sum(df_temp[!is.na(df_temp$n), 2])
    peso_LC <- df_temp/ntot
    ind_year <- indices[indices$year == years[i], 2]
    ind_LC <- peso_LC * ind_year
    for (n in 1:length(ind_LC$LC)) {
      if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
    }
    df_n_LC_M[, i+1] <- ind_LC[,2]
  }
}

write.table(df_n_LC_M,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Males)_RPS.csv", sep=""),sep=";",row.names=F)

for (i in 1:(length(df_n_LC_M)-1)){
  df_n_LC_temp <- df_n_LC_M[,c(1,(i+1))]
  df_n_LC_temp[,3] <- as.numeric(colnames(df_n_LC_M)[i+1])
  colnames(df_n_LC_temp) <- c("LC", "frequency", "year")

  if (i == 1){ df_n_LC_gg <- df_n_LC_temp } else {
    df_n_LC_gg <- rbind(df_n_LC_gg, df_n_LC_temp)
  }
}
df_n_LC_gg$year <- factor(df_n_LC_gg$year)

max_freq <- max(df_n_LC_M[,2:length(df_n_LC_M)])*1.2

ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
  geom_line() +     # Set linetype by sex       # Use larger points, fill with white
  xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
  ggtitle("LFD (Males)") +     # Set title
  xlim(min_lc, max_lc) +
  ylim(0,max_freq) +
  theme_bw()
ggsave(paste(wd,"/output/LFD_(Males)_",sspp,"_GSA",GSA,"_RPS.jpg", sep=""),width=7, height=5)

}  else {
  cat("Not enough data for LFD estimation of Males\n")
}
