merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

# indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Stratified_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)

class_code <- unique(merge_TATC[merge_TATC$GENUS != -1, "LENGTH_CLASSES_CODE"])
if (class_code == "m") {LC <- 1} else {
  if (class_code == "0") {LC <- 5} else {
    if (class_code == "1") {LC <- 10}
  }
}


ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1,]

if (nrow(ddd) != 0) {

ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
years <- sort(unique(ddd$YEAR))

L_classes <- seq(lmin, lmax, LC)
df_n_LC <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
colnames(df_n_LC) <- c("Classe", years)
df_n_LC[,1] <- L_classes
L_classes <- data.frame(LC = L_classes)
i=1
 for (i in 1:length(years)) {
   dd <- ddd[ddd$YEAR ==years[i] ,]   #& ddd$MEAN_DEPTH >= depth_range[1] & ddd$MEAN_DEPTH < depth_range[2]
   check_sex <- length(dd[ , 1])
   if( check_sex != 0 ){
   n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
   colnames(n_LC) <- c("LC", "n")
   df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
   ntot <- sum(df_temp[!is.na(df_temp$n), 2])
   peso_LC <- df_temp/ntot
   ind_year <- indices[indices$year == years[i], 2]
   ind_LC <- peso_LC * ind_year
   for (n in 1:length(ind_LC$LC)) {
     if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
   }
   df_n_LC[, i+1] <- ind_LC[,2]
   } else {
     min_LC <- lmin
     n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
     colnames(n_LC) <- c("LC", "n")
     n_LC[1,1] <- min_LC
     n_LC[1,2] <- 0
     df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
     ntot <- sum(df_temp[!is.na(df_temp$n), 2])
     peso_LC <- df_temp/ntot
     ind_year <- indices[indices$year == years[i], 2]
     ind_LC <- peso_LC * ind_year
     for (n in 1:length(ind_LC$LC)) {
       if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
     }
     df_n_LC[, i+1] <- ind_LC[,2]
   }
 }

write.table(df_n_LC,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Combined)_SRS.csv", sep=""),sep=";",row.names=F)
i=1

min_lc <-min(merge_TATC$LENGTH_CLASS)
max_lc <-max(merge_TATC$LENGTH_CLASS)
max_freq <- max(df_n_LC[,2:length(df_n_LC)])*1.2

for (i in 1:(length(df_n_LC)-1)){
df_n_LC_temp <- df_n_LC[,c(1,(i+1))]
df_n_LC_temp[,3] <- as.numeric(colnames(df_n_LC)[i+1])
colnames(df_n_LC_temp) <- c("LC", "frequency", "year")

if (i == 1){ df_n_LC_gg <- df_n_LC_temp } else {
  df_n_LC_gg <- rbind(df_n_LC_gg, df_n_LC_temp)
}
}
df_n_LC_gg$year <- factor(df_n_LC_gg$year)
ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
  geom_line() +     # Set linetype by sex       # Use larger points, fill with white
  xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
  ggtitle("LFD (Combined)") +     # Set title
  xlim(min_lc, max_lc) +
  ylim(0,max_freq) +
  theme_bw()
ggsave(paste(wd,"/output/LFD_(Combined)_",sspp,"_GSA",GSA,"__SRS.jpg", sep=""),width=7, height=5)

} else {
  cat("Not enough data for LFD estimation\n")
}
#------------
# FEMALES
#------------

merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
# indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Stratified_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-FEMALES-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)

ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1 & merge_TATC$SEX == "F",]

if (nrow(ddd) != 0) {

ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
years <- sort(unique(ddd$YEAR))

L_classes <- seq(lmin, lmax, LC)
df_n_LC_M <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
colnames(df_n_LC_M) <- c("Classe", years)
df_n_LC_M[,1] <- L_classes
L_classes <- data.frame(LC = L_classes)
i=1
for (i in 1:length(years)) {
  dd <- ddd[ddd$YEAR ==years[i] ,]      # & ddd$MEAN_DEPTH >= depth_range[1] & ddd$MEAN_DEPTH < depth_range[2]
  check_sex <- length(dd[ , 1])
  if( check_sex != 0 ){
  n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
  colnames(n_LC) <- c("LC", "n")
  df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
  ntot <- sum(df_temp[!is.na(df_temp$n), 2])
  peso_LC <- df_temp/ntot
  ind_year <- indices[indices$year == years[i], 2]
  ind_LC <- peso_LC * ind_year
  for (n in 1:length(ind_LC$LC)) {
    if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
  }
  df_n_LC_M[, i+1] <- ind_LC[,2]
  } else {
    min_LC <- lmin
    n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
    colnames(n_LC) <- c("LC", "n")
    n_LC[1,1] <- min_LC
    n_LC[1,2] <- 0
    df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
    ntot <- sum(df_temp[!is.na(df_temp$n), 2])
    peso_LC <- df_temp/ntot
    ind_year <- indices[indices$year == years[i], 2]
    ind_LC <- peso_LC * ind_year
    for (n in 1:length(ind_LC$LC)) {
      if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
    }
    df_n_LC_M[, i+1] <- ind_LC[,2]
  }
}

write.table(df_n_LC_M,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Females)_SRS.csv", sep=""),sep=";",row.names=F)

for (i in 1:(length(df_n_LC_M)-1)){
  df_n_LC_temp <- df_n_LC_M[,c(1,(i+1))]
  df_n_LC_temp[,3] <- as.numeric(colnames(df_n_LC_M)[i+1])
  colnames(df_n_LC_temp) <- c("LC", "frequency", "year")

  if (i == 1){ df_n_LC_gg <- df_n_LC_temp } else {
    df_n_LC_gg <- rbind(df_n_LC_gg, df_n_LC_temp)
  }
}
df_n_LC_gg$year <- factor(df_n_LC_gg$year)

max_freq <- max(df_n_LC_M[,2:length(df_n_LC_M)])*1.2

ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
  geom_line() +     # Set linetype by sex       # Use larger points, fill with white
  xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
  ggtitle("LFD (Females)") +     # Set title
  xlim(min_lc, max_lc) +
  ylim(0,max_freq) +
  theme_bw()
ggsave(paste(wd,"/output/LFD_(Females)_",sspp,"_GSA",GSA,"_SRS.jpg", sep=""),width=7, height=5)

} else {
  cat("Not enough data for LFD estimation of Females\n")
}
#------------
# MALES
#------------

merge_TATC <-  read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
# indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Stratified_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
indices <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-MALES-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)

ddd <- merge_TATC[merge_TATC$LENGTH_CLASS != -1 & merge_TATC$SEX == "M",]

if (nrow(ddd) != 0) {

ddd$n_raised <- ddd$NUMBER_OF_INDIVIDUALS_IN_THE_LENGTH_CLASS_AND_MATURITY_STAGE * ddd$RAISING_FACTOR
lmin <- min(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
lmax <- max(ddd[!is.na(ddd$LENGTH_CLASS) & ddd$LENGTH_CLASS != -1,"LENGTH_CLASS"])
years <- sort(unique(ddd$YEAR))

L_classes <- seq(lmin, lmax, LC)
df_n_LC_M <- data.frame(matrix(NA, nrow= length(L_classes), ncol=length(years)+1))
colnames(df_n_LC_M) <- c("Classe", years)
df_n_LC_M[,1] <- L_classes
L_classes <- data.frame(LC = L_classes)
i=1
for (i in 1:length(years)) {
  dd <- ddd[ddd$YEAR ==years[i] ,]     # & ddd$MEAN_DEPTH >= depth_range[1] & ddd$MEAN_DEPTH < depth_range[2]
  check_sex <- length(dd[ , 1])
  if( check_sex != 0 ){
  n_LC <- aggregate(dd$n_raised, by=list(dd$LENGTH_CLASS), sum)
  colnames(n_LC) <- c("LC", "n")
  df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
  ntot <- sum(df_temp[!is.na(df_temp$n), 2])
  peso_LC <- df_temp/ntot
  ind_year <- indices[indices$year == years[i], 2]
  ind_LC <- peso_LC * ind_year
  for (n in 1:length(ind_LC$LC)) {
    if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
  }
  df_n_LC_M[, i+1] <- ind_LC[,2]
  } else {
    min_LC <- lmin
    n_LC <- data.frame(matrix(NA, ncol=2, nrow=1))
    colnames(n_LC) <- c("LC", "n")
    n_LC[1,1] <- min_LC
    n_LC[1,2] <- 0
    df_temp <- merge(L_classes, n_LC,by.x ="LC",  by.y="LC", all.x =T)
    ntot <- sum(df_temp[!is.na(df_temp$n), 2])
    peso_LC <- df_temp/ntot
    ind_year <- indices[indices$year == years[i], 2]
    ind_LC <- peso_LC * ind_year
    for (n in 1:length(ind_LC$LC)) {
      if (is.na(ind_LC$n[n])) {ind_LC$n[n] <- 0} else {ind_LC$n[n] <- ind_LC$n[n]}
    }
    df_n_LC_M[, i+1] <- ind_LC[,2]
  }
}

write.table(df_n_LC_M,paste(wd, "/output/",sspp,"_GSA",GSA,"_LFD_(Males)_SRS.csv", sep=""),sep=";",row.names=F)

for (i in 1:(length(df_n_LC_M)-1)){
  df_n_LC_temp <- df_n_LC_M[,c(1,(i+1))]
  df_n_LC_temp[,3] <- as.numeric(colnames(df_n_LC_M)[i+1])
  colnames(df_n_LC_temp) <- c("LC", "frequency", "year")

  if (i == 1){ df_n_LC_gg <- df_n_LC_temp } else {
    df_n_LC_gg <- rbind(df_n_LC_gg, df_n_LC_temp)
  }
}
df_n_LC_gg$year <- factor(df_n_LC_gg$year)

max_freq <- max(df_n_LC_M[,2:length(df_n_LC_M)])*1.2

ggplot(data=df_n_LC_gg, aes(x=LC, y=frequency, group=year, colour=year)) +
  geom_line() +     # Set linetype by sex       # Use larger points, fill with white
  xlab("LC") + ylab(expression(paste("Abundance ", (n/km^2), sep=" "))) + # Set axis labels
  ggtitle("LFD (Males)") +     # Set title
  xlim(min_lc, max_lc) +
  ylim(0,max_freq) +
  theme_bw()
ggsave(paste(wd,"/output/LFD_(Males)_",sspp,"_GSA",GSA,"_SRS.jpg", sep=""),width=7, height=5)

} else {
  cat("Not enough data for LFD estimation of Males\n")
}
