#-----------------------
# MIW INDICES
#-----------------------

merge_TATB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

dependent <- "MIW"
dep_text <-"MIW (kg)"
# varcol <- which(colnames(merge_TATB)=="kg_km2")
# col_response <- which(colnames(merge_TATB)=="kg_km2")
GENERE <- as.character(unique(merge_TATB$GENUS)[unique(merge_TATB$GENUS) != -1])
SPECIE <- as.character(unique(merge_TATB$SPECIES)[unique(merge_TATB$SPECIES) != -1])
sspp <- paste(GENERE,SPECIE, sep="")
GSA <- unique(merge_TATB$GSA)
species <- sspp

# timeseries <- res_table_cala2


ddd <- merge_TATB
year_range <- data.frame(year = sort(unique(merge_TATB$YEAR)))

res_table_cala2 <- data.frame(year=sort(unique(merge_TATB$YEAR)))
res_table_cala2$MIW <- NA
res_table_cala2$sd <- NA
res_table_cala2$CV <- NA
res_table_cala2$incCV <- NA


i=1
for(i in 1:length(res_table_cala2[,1])) {

  data2 <- ddd[ddd$YEAR == res_table_cala2[i,1] , ]


  #index computation
  data2 <- data2[!is.na(data2$TOTAL_NUMBER_IN_THE_HAUL ) & data2$TOTAL_NUMBER_IN_THE_HAUL>0, ]
  res_table_cala2[i,2] <- (sum(data2[ , "TOTAL_WEIGHT_IN_THE_HAUL" ])/1000) / sum(data2[ , "TOTAL_NUMBER_IN_THE_HAUL" ])

  if (length(data2[,1])>0){
    data2$MIWc<- (data2[ ,"TOTAL_WEIGHT_IN_THE_HAUL"]/1000)/data2[ ,"TOTAL_NUMBER_IN_THE_HAUL"]

    if (length(data2[,1])>1){
        data2$sq <- (res_table_cala2[i,2] - data2$MIWc)^2
        res_table_cala2[i,3] <- sqrt(sum(data2$sq)/(length(data2[,1])-1))
        res_table_cala2[i,4] <- res_table_cala2[i,3] / res_table_cala2[i,2]
        res_table_cala2[i,5] <- 1 / res_table_cala2[i,4]
  } else {
        res_table_cala2[i,3] <- NA
        res_table_cala2[i,4] <- NA
        res_table_cala2[i,5] <- NA

        }

  } else {
    res_table_cala2[i,2] <- NA
    res_table_cala2[i,3] <- NA
    res_table_cala2[i,4] <- NA
    res_table_cala2[i,5] <- NA
  }

}

timeseries <- res_table_cala2
MIW_TS  <- res_table_cala2


# plot timeseries of mean indices
main <- paste(sspp,"_GSA",GSA,"_(",dependent,")-Simple_Random_Sampling_", sep="")
main.lab <- paste(sspp," GSA",GSA," (",dependent,")-Simple_Random_Sampling ", sep="")
max_index <- max(timeseries[,2]) + max(timeseries[,3])
write.table(timeseries, paste(wd,"/output/",main,"_Timeseries.csv", sep=""), sep=";", row.names = F)

tiff(paste(wd,"/output/",main,"_Timeseries.tiff",sep=""), res = 300, width = 8, height = 7, units = 'in', compression = 'lzw', pointsize = 1/300)
par(mfrow=c(1,1),oma=c(1,1,1,1), mgp=c(2, 1,0))
plot(timeseries[,1],  timeseries[,2], type="b", col="black", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab=dep_text, main=main.lab) # ylim=c(0,max_index*1.2)
lines(timeseries[,1], (timeseries[,2]-1.96*timeseries[,3]), type="l",lty=2, col="red" )
lines(timeseries[,1], (timeseries[,2]+1.96*timeseries[,3]), type="l",lty=2, col="red" )
legend("topright", c("time series", "CI"), lty=c(1,2), pch=c(16, NA), col=c("black","red"))
dev.off()

cat("\n Estimation of MIW completed \n")
