cat("\n########################\n")
cat("Check of survey data\n")
cat("########################\n")
cat("\n")

checks_count <- 0

#####################################################
## check if the same gear was used along the years ##
#####################################################
gear_codes <- unique(as.character(TA$GEAR))
ngear <- length(gear_codes)
if (ngear > 1) {
  cat(paste("\nDuring the survey", ngear," different gears were used. The standardization of the indices with GLM/GAM models is suggested.\n"))
  checks_count <- checks_count + 1
  }


#######################################################
## check if the same vessel was used along the years ##
#######################################################

vessel_codes <- unique(as.character(TA$VESSEL))
nvessel <- length(vessel_codes)
if (nvessel > 1) {
  cat(paste("\nDuring the survey", nvessel," different vessels were used. The standardization of the indices with GLM/GAM models is suggested.\n"))
  checks_count <- checks_count + 1
  }


################################################################
## check if the same number of hauls was used along the years ##
################################################################

hauls_per_year  <- aggregate(TA$HAUL_NUMBER, by=list(TA$YEAR), length)
nhauls <- as.factor(hauls_per_year[,2])

if (length(nhauls) > 1) {
  cat(paste("\nDuring the survey a different number of hauls per year was used. The standardization of the indices with GLM/GAM models is suggested.\n"))
  checks_count <- checks_count + 1
  }

####################################
## Bubble plots of Hauls position ##
####################################
cat("Please, wait a moment. Elaboration of the hauls plot in progress\n")

source(paste(wd, "/scripts/Bubble_plots.r", sep=""))

cat("\nPlease, check the plot of the hauls position in the output folder\n")
check4 <- toupper(dlgInput("\nPlease, check the plot of the hauls position in the output folder\nWere the hauls located in same position along the years? (Y/N)", default="Y",Sys.info()[""])$res)

if(as.character(check4) == "Y" | as.character(check4) == "y"){
  checks_count <- checks_count
} else { if(as.character(check4) == "N" | as.character(check4) == "n") {
  checks_count <- checks_count +1
}

}


###########
# Results #
###########
if (checks_count != 0) {
  cat(paste("\n",checks_count," check/s over 4 indicate/s that the standardization of the indices with GLM/GAM models is reccomended\n"))
}


