# threshold_to_ind_weight_calc <- 30

depthstr <- menu(c("10-200","10-800","200-800","5-35","5-45") ,title=  paste("\fOnly the hauls between ",depth_range[1],"m and ",depth_range[2],"m are selected for the analysis.\nChoose the depth strata to be used for the map output -> ", sep="")  )

if (depthstr == "5-45" | depthstr == 5){
  cgpmgrid <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/GRID_0-45.shp", sep=""), verbose=F)
}

if (depthstr == "5-35" | depthstr == 4){
  cgpmgrid <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/GRID_0-35.shp", sep=""), verbose=F)
}

if (depthstr == "10-200" | depthstr == 1){
  cgpmgrid <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/GRID_0-200.shp", sep=""), verbose=F)
}

if (depthstr == "10-800" | depthstr == 2){
  cgpmgrid <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/GRID_0-800.shp", sep=""), verbose=F)
}

if (depthstr == "200-800" | depthstr == 3){
  cgpmgrid <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/GRID_0-800.shp", sep=""), verbose=F)
  mask <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/GRID_0-200.shp", sep=""), verbose=F)
  mask <- spTransform(mask, CRS("+proj=longlat"))
}

cgpmgrid <- spTransform(cgpmgrid, CRS("+proj=longlat"))
continent <- readOGR(paste(wd, "/scripts/utilities/continent/continent.shp", sep=""), verbose=F)
continent<- spTransform(continent, CRS("+proj=longlat"))

# plot(grid_0_800, col="grey")
# plot(grid_0_200, col="white", add=T)

metaDB <- read.table(paste(wd, "/output/",sspp," - allGSAs_metaDB_catch in GRID.csv",sep=""), sep=";",header = T)
metaDB <- metaDB[metaDB$MEAN_DEPTH > depth_range[1] & metaDB$MEAN_DEPTH <= depth_range[2] , ]

# }
GENERE <- as.character(unique(metaDB$GENUS)[unique(metaDB$GENUS) != -1])
SPECIE <- as.character(unique(metaDB$SPECIES)[unique(metaDB$SPECIES) != -1])
sspp <- paste(GENERE,SPECIE, sep="")

# dir_file <- data.frame(files=dir(paste(wd, "/output/",sep=""), pattern = ".csv", full.names = TRUE, ignore.case = TRUE))
# if (file.exists(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Penalized_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""))){
#   timeseries <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Penalized_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
# }
# if (file.exists(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Simple_Random_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""))){
#   timeseries <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Simple_Random_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
# }
# if (file.exists(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Stratified_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""))){
# timeseries <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Random_Stratified_Sampling_",depth_range[1],"-",depth_range[2]," m_Timeseries.csv", sep=""), sep=";", header=T)
# }


years <- sort(unique(metaDB[,"YEAR"]))

if (length(years) < 10) {
  n_years <- as.numeric(dlgInput(paste("There are less than 10 years (", length(years),") of survey\nHow many of the last  years do you want to consider in the analysis? --> ", sep=""), default="",Sys.info()[""])$res)
  firstyear <- years[length(years)-(n_years-1)]
  last_10year <- years[years >= firstyear]
} else {
  firstyear <- years[length(years)-9]
  last_10year <- years[years >= firstyear]
}

# firstyear <- timeseries[length(timeseries$year)-9,1]
# last10year <- years[years >= firstyear]

metaDB <- metaDB[ metaDB$YEAR %in% last_10year,]
# metaDB <- metaDB[ metaDB$YEAR %in% last_5_years,]

colnames(metaDB)[colnames(metaDB) == "cgpmgrid_id"] <- "CGPMgrid"
colnames(metaDB)[colnames(metaDB) == "kg_km2"] <- "B_km2"
colnames(metaDB)[colnames(metaDB) == "kg_h"] <- "B_h"

# Create Mean Fish Weight by haul
metaDB$MEAN_WEIGHT <- round(metaDB$TOTAL_WEIGHT_IN_THE_HAUL/metaDB$TOTAL_NUMBER_IN_THE_HAUL,3)/1000

#----------------------------------------
# CALCULATION OF THE ABUNDANCE and saving the tables
#----------------------------------------
nhauls.grid <- aggregate(metaDB$N_km2, by=list(metaDB$CGPMgrid, metaDB$x_center, metaDB$y_center), length) # [,4]
colnames(nhauls.grid) <- c("CGPMgrid", "x_center", "y_center", "nhauls")

cgpmgridlevel <- unique(metaDB$CGPMgrid)
ntab <- data.frame(CGPMgrid = cgpmgridlevel, GSA = unique(metaDB$GSA))
ntab$meanNkm2 <- NA
i=1
for (i in 1:length(cgpmgridlevel)){
  ddd <- metaDB[metaDB$CGPMgrid == cgpmgridlevel[i], ]
  ntab[i,3] <- mean(ddd[!is.na(ddd$N_km2), "N_km2"])
  ssd <- (ddd$N_km2 - ntab[i,3])^2   # sum of squared differences
  variance <- sum(ssd)/(length(ddd$N_km2)-1) # variance
  ntab$sdNkm2[i] <- sqrt(variance)
  ntab$cvNkm2[i] <- sqrt(variance)/ntab[i,3]
  ntab$inverse_cvNkm2[i] <- 1/ntab$cvNkm2[i]
  ntab$nhauls_in_square[i] <- length(ddd[, "HAUL_NUMBER"])
  ntab$nhauls_positive[i] <- length(ddd[ddd$N_km2 > 0, "HAUL_NUMBER"])
}

summary.grid <- merge(ntab, nhauls.grid[,1:3])
colnames(summary.grid) <- c("cgpmgridlevel", "GSA", "meanNkm2", "sdNkm2", "cvNkm2", "inverse_cvNkm2","nhauls","positive_hauls", "lon", "lat" )

abundance_grid <- summary.grid
write.table(abundance_grid, paste(wd, "/output/",sspp," - GFCM GRID ABUNDANCE.csv", sep=""), sep=";", row.names=FALSE)

cat("Abundance indices for statistical squares correctly estimated \ninverse of CV of abundance indices for statistical squares correctly estimated \n")
cat(paste("file of abundance indices for statistical squares saved in the following folder: '",wd, "/output/",sspp," - GFCM GRID ABUNDANCE.csv \n",sep=""))

#----------------------------------------
# CALCULATION OF THE BIOMASS and saving the tables
#----------------------------------------
nhauls.grid <- aggregate(metaDB$B_km2, by=list(metaDB$CGPMgrid, metaDB$x_center, metaDB$y_center), length) # [,4]
colnames(nhauls.grid) <- c("CGPMgrid", "x_center", "y_center", "nhauls")

cgpmgridlevel <- unique(metaDB$CGPMgrid)
Btab <- data.frame(CGPMgrid = cgpmgridlevel, GSA = unique(metaDB$GSA))
Btab$meanBkm2 <- NA
i=1
for (i in 1:length(cgpmgridlevel)){
  ddd <- metaDB[metaDB$CGPMgrid == cgpmgridlevel[i], ]
  Btab[i,3] <- mean(ddd[!is.na(ddd$B_km2), "B_km2"])
  ssd <- (ddd$B_km2 - Btab[i,3])^2   # sum of squared differences
  variance <- sum(ssd)/(length(ddd$B_km2)-1) # variance
  Btab$sdBkm2[i] <- sqrt(variance)
  Btab$cvBkm2[i] <- sqrt(variance)/Btab[i,3]
  Btab$inverse_cvBkm2[i] <- 1/Btab$cvBkm2[i]
  Btab$nhauls_in_square[i] <- length(ddd[, "HAUL_NUMBER"])
  Btab$nhauls_positive[i] <- length(ddd[ddd$B_km2 > 0, "HAUL_NUMBER"])
}

summary.grid <- merge(Btab, nhauls.grid[,1:3])
colnames(summary.grid) <- c("cgpmgridlevel", "GSA", "meanBkm2", "sdBkm2", "cvBkm2", "inverse_cvBkm2","nhauls","positive_hauls", "lon", "lat" )

biomass_grid <- summary.grid
write.table(biomass_grid, paste(wd, "/output/",sspp," - GFCM GRID BIOMASS.csv", sep=""), sep=";", row.names=FALSE)

cat("Biomass indices for statistical squares correctly estimated \n")
cat(paste("file of Biomass indices for statistical squares saved in the following folder: '",wd, "/output/",sspp," - GFCM GRID BIOMASS.csv \n",sep=""))

#----------------------------------------
# Calculating mean weight
#----------------------------------------

nhauls.grid <- aggregate(metaDB$N_km2, by=list(metaDB$CGPMgrid, metaDB$x_center, metaDB$y_center), length) # [,4]
colnames(nhauls.grid) <- c("CGPMgrid", "x_center", "y_center", "nhauls")

cgpmgridlevel <- unique(metaDB$CGPMgrid)
MIWtab <- data.frame(CGPMgrid = cgpmgridlevel, GSA = unique(metaDB$GSA))
MIWtab$MIW <- NA
i=1
for (i in 1:length(cgpmgridlevel)){
  ddd <- metaDB[metaDB$CGPMgrid == cgpmgridlevel[i], ]
  MIWtab[i,3] <- sum(ddd[!is.na(ddd$MEAN_WEIGHT) & ddd$MEAN_WEIGHT>0, "MEAN_WEIGHT"])/length(ddd[!is.na(ddd$MEAN_WEIGHT) & ddd$MEAN_WEIGHT>0, "MEAN_WEIGHT"])
  ssd <- (ddd[!is.na(ddd$MEAN_WEIGHT) & ddd$MEAN_WEIGHT >0, "MEAN_WEIGHT"] - MIWtab[i,3])^2   # sum of squared differences
  variance <- sum(ssd)/(length(ddd[!is.na(ddd$MEAN_WEIGHT) & ddd$MEAN_WEIGHT>0, "MEAN_WEIGHT"])-1) # variance
  MIWtab$sdNkm2[i] <- sqrt(variance)
  MIWtab$cvNkm2[i] <- sqrt(variance)/MIWtab[i,3]
  MIWtab$inverse_cvNkm2[i] <- 1/MIWtab$cvNkm2[i]
  MIWtab$nhauls_in_square[i] <- length(ddd[, "HAUL_NUMBER"])
  MIWtab$nhauls_positive[i] <- length(ddd[!is.na(ddd$N_km2) & ddd$N_km2 > 0, "HAUL_NUMBER"])
}

summary.grid <- merge(MIWtab, nhauls.grid[,1:3])
colnames(summary.grid) <- c("cgpmgridlevel", "GSA", "MIW", "sdMIW", "cvMIW", "inverse_cvMIW","nhauls","positive_hauls", "lon", "lat" )

meanWEIGHT_grid <- summary.grid
write.table(meanWEIGHT_grid, paste(getwd(), "/output/",sspp," - GFCM GRID MIW.csv", sep=""), sep=";", row.names=FALSE)

cat("MIW for statistical squares correctly estimated \ninverse of CV of MIW for statistical squares correctly estimated \n")
cat(paste("file of MIW for statistical squares saved in the following folder: '",wd, "/output/",sspp," - GFCM GRID MIW.csv \n",sep=""))

#----------------------------------------
# Plotting indices
#----------------------------------------
source(paste(wd, "/scripts/plotGFCM.r", sep=""))

# source(paste(wd, "/scripts/plotGFCM_Abundance.r", sep=""))
# source(paste(wd, "/scripts/plotGFCM_Biomass.r", sep=""))
# source(paste(wd, "/scripts/plotGFCM_MIW.r", sep=""))

