load_libraries <- function () {

  libs <- c("sp", "hms", "mgcv", "rgdal", "tcltk2", "ggplot2", "gridExtra", "svDialogs", "MEDITS","reshape2")
  nlib <- length(libs)
  installed <- rep(NA, nlib)

  for (l in 1:nlib) {
    installed[l] <- suppressWarnings( library( as.character(libs[l]), logical.return=TRUE, character.only=TRUE)  )
  }

  if (!(any(installed))) {
    to.be.installed <- which(!(installed))
    if (length(to.be.installed)>1){
        text.install <- paste(libs[to.be.installed], collate=",", sep="")
    } else if (length(to.be.installed)==1) {
      text.install <- libs[to.be.installed]
    }

    resp.inst <- menu(c("Yes","No"),paste("The following packages are missing: ", text.install,". Would you like to install missing packages? "))

    if (resp.inst == 1) {
      i=1
      for (i in 1:length(to.be.installed)){
            install.packages(libs[to.be.installed[i]])
        }
    }

  }

  for (l in 1:nlib) {
    library( as.character(libs[l]), character.only=TRUE)
  }

  if (!(suppressWarnings( library("RoMEBS" , logical.return=TRUE, character.only=TRUE) ) ) ) {
    install.packages("https://github.com/COISPA/R_libraries/raw/main/RoMEBS_0.2.01.zip",repos = NULL)
    library(RoMEBS)
  }


}
