cat("\n########################\n")
cat("spatial metaDB preparation\n")
cat("########################\n")
cat("\n")

cgpmgrid <- readOGR(paste(wd, "/scripts/utilities/gfcmstatp/gfcmstatp_centr.shp", sep=""), verbose=F)
cgpmgrid <- spTransform(cgpmgrid, CRS("+proj=longlat"))

metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

GENERE <- as.character(unique(metaDB$GENUS)[unique(metaDB$GENUS) != -1])
SPECIE <- as.character(unique(metaDB$SPECIES)[unique(metaDB$SPECIES) != -1])
sspp <- paste(GENERE,SPECIE, sep="")
coordinates(metaDB) <- c("MEAN_LONGITUDE_DEC","MEAN_LATITUDE_DEC")
#metaDB <- spTransform(metaDB, CRS("+proj=longlat +ellps=WGS84"))
proj4string(metaDB) <- CRS("+proj=longlat") # Set the coordinate system

# Overlay metaDB with the grid
overlay <- over(metaDB, cgpmgrid, returnlist=TRUE)
metaDBnew_georef <- data.frame(metaDB, x_center= overlay$gfcm.cen_5,y_center=overlay$gfcm.cen_6 ,cgpmgrid_id=overlay$GFCM_ID)

centroidi <- readOGR(paste(getwd(), "/scripts/utilities/gfcm-centroidi/gfcm-centroidi.shp", sep=""), verbose=F)
proj4string(centroidi) <- CRS("+proj=longlat")
centroidi_coords <- cbind(centroidi@coords, centroidi@data$GFCM_ID)

#plot(cgpmgrid)
#plot(centroidi, pch=16, col="red", add=T, cex=.3)
write.table(metaDBnew_georef, paste(wd, "/output/",sspp," - allGSAs_metaDB_catch in GRID.csv",sep=""), sep=";", row.names=F)
cat(paste("Catch metaDB saved in the following folder: '",wd, "/output/",sspp," - allGSAs_metaDB_catch in GRID.csv \n",sep=""))
cat("\n")
if (any(is.na(metaDBnew_georef$cgpmgrid_id))) {
  message("One or more hauls are out of the reference grid area. Data from these hauls should be excluded by statial analysis.")
  cat("\n")
}

# Read metaDB file and transform into spatial object
metaDB <- read.table(paste(wd, "/output/mergeTATC_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

coordinates(metaDB) <- c("MEAN_LONGITUDE_DEC","MEAN_LATITUDE_DEC")
proj4string(metaDB) <- CRS("+proj=longlat")  # Set the coordinate system

# Overlay metaDB with the grid
overlay <- over(metaDB, cgpmgrid, returnlist=TRUE)
metaDBnew_georef <- data.frame(metaDB, x_center= overlay$gfcm.cen_5,y_center=overlay$gfcm.cen_6 ,cgpmgrid_id=overlay$GFCM_ID)

#plot(cgpmgrid)
#plot(centroidi, pch=16, col="red", add=T, cex=.3)
write.table(metaDBnew_georef, paste(wd, "/output/",sspp," - allGSAs_metaDB_biological in GRID.csv",sep=""), sep=";", row.names=F)
cat(paste("Biological metaDB saved in the following folder: '",wd, "/output/",sspp," - allGSAs_metaDB_biological in GRID.csv \n",sep=""))
cat("\n")
if (any(is.na(metaDBnew_georef$cgpmgrid_id))) {
  message("One or more hauls are out of the reference grid area. Data from these hauls should be excluded by statial analysis.")
  cat("\n")
}
