#####################
#####################
###               ###
###   ABUNDANCE   ###
###               ###
#####################
#####################

summary.grid <- read.csv(paste(wd, "/output/",sspp," - GFCM GRID ABUNDANCE.csv", sep=""), sep=";")
metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]

if (nrow(map_range)>1) {
  if (check_country=="Y") {
    x1 <- min(map_range$xmin)
    x2 <- max(map_range$xmax)
    y1 <- min(map_range$ymin)
    y2 <- max(map_range$ymax)
    map_range <- map_range[1,]
    map_range[1,3] <- x1
    map_range[1,4] <- x2
    map_range[1,5] <- y1
    map_range[1,6] <- y2
  }
}

#----------------------------------------
# Saving maps of the ABUNDANCE index
#----------------------------------------                                                                          # [summary.grid$meanNkm2>5]
cat_lim <- as.numeric(quantile(summary.grid[!is.na(summary.grid$meanNkm2), "meanNkm2"], probs = seq(0, 1,0.20) ) )
#cat_lim[1] <- 0
#  cate_label[len] <- ifelse( round(cat_lim[len],0) != 0, round(cat_lim[len],0), ifelse( round(cat_lim[len],1) != 0,  round(cat_lim[len],1),  round(cat_lim[len],2)))
cate_label <-   round(cat_lim,1)
cate_label_min <- cate_label
#cate_label_min[1] <- 0
cate_label_max <- cate_label[2:length(cate_label)]


cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")

#cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )
cate_label <- cate_label[1: (length(cate_label)-1)]

palette_cate <- heat.colors(length(cate_label))
palette_cate <- palette_cate[length(palette_cate):1]

cgpmgrid@data$abundance <- NA
cgpmgrid@data$color <- "#FFFFFF"
i=2
for (i in 1:length(summary.grid[,1])){
  cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- summary.grid[i,"meanNkm2"]
  if(all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[2])  & all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] >= cat_lim[1])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[1]
  }

  if(all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[3] ) & all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[2])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[2]
  }

  if(all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[4])  & all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[3])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[3]
  }

  if(all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[5])  & all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[4])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[4]
  }

  if(all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[6])  & all(cgpmgrid@data$abundance[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[5])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[5]
  }
}


lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
ratio <- ly/lx
img_width <- 30
img_height <- img_width*ratio

# jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID ABUNDANCE.jpg", sep = ""), width=img_width, height=img_height, bg="white", units="cm",res=200)
jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID ABUNDANCE.jpg", sep = ""), width=25, height=25, bg="white", units="cm",res=200)
par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
plot(1,1,type="n",xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]) ,  xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste(paste("Abundance  (n/km^2)", sep=" "), sspp), asp=1)
plot(cgpmgrid,col=cgpmgrid$color, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")                                                                                 #data = centroidi_coords,
      if (depthstr == "200-800" | depthstr == 3){
          plot(mask,col="white", xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")
      }
plot(continent, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), border="grey", col="light grey", add=T)
legend("topleft", cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "Abundance (n/km^2)\n(classes based on percentiles)", bty = "n")
# legend(map_range[1,"xmin"],map_range[1,"ymax"], cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "Abundance (n/km^2)\n(classes based on percentiles)", bty = "n")
box()
dev.off()

#----------------------------------------
# Saving maps of the inverse of CV of ABUNDANCE index
#----------------------------------------
cat_lim <- quantile(summary.grid$inverse_cvNkm2[!is.na(summary.grid$inverse_cvNkm2)], probs = seq(0, 1,0.20) )
cate_label <-  round(cat_lim,3)

cate_label_min <- cate_label
cate_label_max <- cate_label[2:length(cate_label)]


cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")

#cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )
cate_label <- cate_label[1: (length(cate_label)-1)]

palette_cate <- heat.colors(length(cate_label))
palette_cate <- palette_cate[length(palette_cate):1]

cgpmgrid@data$invCV <- NA
cgpmgrid@data$color <- "#FFFFFF"

i=3
for (i in 1:length(summary.grid[,1])){
  cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- summary.grid[i,"inverse_cvNkm2"]

  if(all(is.na(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]])) ){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- "#FFFFFF"
  } else {

  if(all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[2])  & all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] >= cat_lim[1])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[1]
  }

  if(all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[3])  & all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[2])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[2]
  }

  if(all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[4])  & all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[3])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[3]
  }

  if(all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[5])  & all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[4])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[4]
  }

  if(all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[6])  & all(cgpmgrid@data$invCV[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[5])){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[5]
  }
    }
}

lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
ratio <- ly/lx
img_width <- 30
img_height <- img_width*ratio


# jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID ABUNDANCE Inverse CV.jpg", sep = ""), width=img_width, height=img_height, bg="white", units="cm",res=200)
jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID ABUNDANCE Inverse CV.jpg", sep = ""), width=25, height=25, bg="white", units="cm",res=200)

par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
plot(1,1,type="n",xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste("Inverse of Abundance CV -", sspp) , asp=1)
plot(cgpmgrid,col=cgpmgrid$color, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")                                                                                 #data = centroidi_coords,
if (depthstr == "200-800" | depthstr == 3){
  plot(mask,col="white", xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")
}
plot(continent, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), border="grey", col="light grey", add=T)
legend("topleft", cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "Inverse of Abundance CV\n(classes based on percentiles)", bty = "n")
# legend(map_range[1,"xmin"],map_range[1,"ymax"], cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "Inverse of Abundance CV\n(classes based on percentiles)", bty = "n")

box()
dev.off()



###################
###################
###             ###
###   BIOMASS   ###
###             ###
###################
###################


summary.grid <- read.csv(paste(wd, "/output/",sspp," - GFCM GRID BIOMASS.csv", sep=""), sep=";")
metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]

if (nrow(map_range)>1) {
  if (check_country=="Y") {
    x1 <- min(map_range$xmin)
    x2 <- max(map_range$xmax)
    y1 <- min(map_range$ymin)
    y2 <- max(map_range$ymax)
    map_range <- map_range[1,]
    map_range[1,3] <- x1
    map_range[1,4] <- x2
    map_range[1,5] <- y1
    map_range[1,6] <- y2
  }
}

#----------------------------------------
# Saving maps of the BIOMASS index
#----------------------------------------

cat_lim <- quantile(summary.grid[!is.na(summary.grid$meanBkm2), "meanBkm2"], probs = seq(0, 1,0.20) )
cate_label <-  round(cat_lim,3)

cate_label_min <- cate_label
# cate_label_min[1] <- 0
cate_label_max <- cate_label[2:length(cate_label)]


cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")

cate_label <- cate_label[1: (length(cate_label)-1)]
# cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )


palette_cate <- heat.colors(length(cate_label))
palette_cate <- palette_cate[length(palette_cate):1]


cgpmgrid@data$meanBkm2 <- NA
cgpmgrid@data$color <- "#FFFFFF"

i=3
for (i in 1:length(summary.grid[,1])){
  cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- summary.grid[i,"meanBkm2"]

  if(all(is.na(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]])) ){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- "#FFFFFF"
  } else {

    if(all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[2] ) & all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] >= cat_lim[1])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[1]
    }

    if(all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[3])  & all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[2])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[2]
    }

    if(all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[4])  & all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[3])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[3]
    }

    if(all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[5])  & all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[4])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[4]
    }

    if(all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[6])  & all(cgpmgrid@data$meanBkm2[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[5])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[5]
    }
  }
}


lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
ratio <- ly/lx
img_width <- 30
img_height <- img_width*ratio


# jpeg(file=paste(wd, "/output/",sspp," - GFCM GRID BIOMASS.jpg", sep = ""), width=img_width, height=img_height, bg="white", units="cm",res=200)
jpeg(file=paste(wd, "/output/",sspp," - GFCM GRID BIOMASS.jpg", sep = ""), width=25, height=25, bg="white", units="cm",res=200)

par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
plot(1,1,type="n",xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste("Biomass (kg/km^2) -", sspp), asp=1 )
plot(cgpmgrid,col=cgpmgrid$color, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")                                                                                 #data = centroidi_coords,
if (depthstr == "200-800" | depthstr == 3){
  plot(mask,col="white", xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")
}
plot(continent, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), border="grey", col="light grey", add=T)

legend("topleft", cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "Biomass (kg/km^2)\n(classes based on percentiles)", bty = "n")
# legend(map_range[1,"xmin"],map_range[1,"ymax"], cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "Biomass (kg/km^2)\n(classes based on percentiles)", bty = "n")

#symbols(summary.grid_to_plot$lon, summary.grid_to_plot$lat, circles=summary.grid_to_plot $meanBkm2, inches=0.3, fg="white", bg="green", add=T)

# with(centroidi_coords, text(centroidi_coords$coords.x1 - 0.5, centroidi_coords$coords.x2,  labels = centroidi_coords$cgpmgrid_id, pos = 4, cex = 0.2, col="grey"))
box()
dev.off()




###################
###################
###             ###
###     MIW     ###
###             ###
###################
###################

summary.grid <- read.csv(paste(wd, "/output/",sspp," - GFCM GRID MIW.csv", sep=""), sep=";")
metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]

if (nrow(map_range)>1) {
  if (check_country=="Y") {
    x1 <- min(map_range$xmin)
    x2 <- max(map_range$xmax)
    y1 <- min(map_range$ymin)
    y2 <- max(map_range$ymax)
    map_range <- map_range[1,]
    map_range[1,3] <- x1
    map_range[1,4] <- x2
    map_range[1,5] <- y1
    map_range[1,6] <- y2
  }
}

#----------------------------------------
# Saving maps of the MIW
#----------------------------------------                                                                          # [summary.grid$meanNkm2>5]
cat_lim <- as.numeric(quantile(summary.grid[!is.na(summary.grid$MIW), "MIW"], probs = seq(0, 1,0.20) ) )
#cat_lim[1] <- 0
#  cate_label[len] <- ifelse( round(cat_lim[len],0) != 0, round(cat_lim[len],0), ifelse( round(cat_lim[len],1) != 0,  round(cat_lim[len],1),  round(cat_lim[len],2)))
cate_label <-   round(cat_lim,3)
cate_label_min <- cate_label
#cate_label_min[1] <- 0
cate_label_max <- cate_label[2:length(cate_label)]


cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")

#cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )
cate_label <- cate_label[1: (length(cate_label)-1)]

palette_cate <- heat.colors(length(cate_label))
palette_cate <- palette_cate[length(palette_cate):1]

cgpmgrid@data$MIW <- NA
cgpmgrid@data$color <- "#FFFFFF"

i=3
for (i in 1:length(summary.grid[,1])){
  cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- summary.grid[i,"MIW"]

  if(all(is.na(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]])) ){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- "#FFFFFF"
  } else {

    if(all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[2])  & all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] >= cat_lim[1])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[1]
    }

    if(all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[3])  & all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[2])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[2]
    }

    if(all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[4])  & all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[3])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[3]
    }

    if(all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[5])  & all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[4])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[4]
    }

    if(all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <= cat_lim[6])  & all(cgpmgrid@data$MIW[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] > cat_lim[5])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==summary.grid[i,"cgpmgridlevel"]] <- palette_cate[5]
    }
  }
}


lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
ratio <- ly/lx
img_width <- 30
img_height <- img_width*ratio

# jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID MIW.jpg", sep = ""), width=img_width, height=img_height, bg="white", units="cm",res=200)
jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID MIW.jpg", sep = ""), width=25, height=25, bg="white", units="cm",res=200)

par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
plot(1,1,type="n",xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]) ,  xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste(paste("Mean Individual Weight  (kg)", sep=" "), sspp), asp=1)
plot(cgpmgrid, col=cgpmgrid$color, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")                                                                                 #data = centroidi_coords,
if (depthstr == "200-800" | depthstr == 3){
  plot(mask,col="white", xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")
}
plot(continent, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), border="grey", col="light grey", add=T)
# symbols(summary.grid_to_plot$lon[order(summary.grid_to_plot $to_plot, decreasing = T)], summary.grid_to_plot$lat[order(summary.grid_to_plot $to_plot, decreasing = T)], circles=as.numeric(as.character(summary.grid_to_plot $to_plot[order(summary.grid_to_plot $to_plot, decreasing = T)])), inches=0.12, fg="grey", bg=summary.grid_to_plot$color[order(summary.grid_to_plot $to_plot, decreasing = T)], add=T)   # inches=1
# points(summary.grid_to_plot$lon[summary.grid_to_plot $to_plot==0], summary.grid_to_plot$lat[summary.grid_to_plot $to_plot==0], pch=4)   # inches=1 ,
legend("topleft", cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "MIW (kg)\n(classes based on percentiles)", bty = "n")
# legend(map_range[1,"xmin"],map_range[1,"ymax"], cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "MIW (kg)\n(classes based on percentiles)", bty = "n")
#with(centroidi_coords, text(centroidi_coords$coords.x1 - 0.5, centroidi_coords$coords.x2, labels = centroidi_coords$cgpmgrid_id, pos = 4, cex = 0.2, col="grey"))
box()
dev.off()





