summary.grid <- read.csv(paste(wd, "/output/",sspp," - GFCM GRID BIOMASS.csv", sep=""), sep=";")
metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]

#----------------------------------------
# Saving maps of the BIOMASS index
#----------------------------------------



cat_lim <- quantile(summary.grid[!is.na(summary.grid$meanBkm2), "meanBkm2"], probs = seq(0, 1,0.20) )
cate_label <-  round(cat_lim,3)

cate_label_min <- cate_label
# cate_label_min[1] <- 0
cate_label_max <- cate_label[2:length(cate_label)]


cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")

cate_label <- cate_label[1: (length(cate_label)-1)]
# cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )


palette_cate <- heat.colors(length(cate_label))
palette_cate <- palette_cate[length(palette_cate):1]

summary.grid_to_plot <- summary.grid
summary.grid_to_plot$cate <- "0"

summary.grid_to_plot$color <- "black"
summary.grid_to_plot$to_plot <- 0

summary.grid_to_plot$color[ summary.grid_to_plot$meanBkm2 >= min(summary.grid_to_plot[!is.na(summary.grid_to_plot$meanBkm2), "meanBkm2"]) & summary.grid_to_plot$meanBkm2 <=cat_lim[2]] <- palette_cate[1]
summary.grid_to_plot$color[ summary.grid_to_plot$meanBkm2 >cat_lim[2] & summary.grid_to_plot$meanBkm2 <=cat_lim[3]] <- palette_cate[2]
summary.grid_to_plot$color[ summary.grid_to_plot$meanBkm2 >cat_lim[3] & summary.grid_to_plot$meanBkm2 <=cat_lim[4]] <- palette_cate[3]
summary.grid_to_plot$color[ summary.grid_to_plot$meanBkm2 >cat_lim[4] & summary.grid_to_plot$meanBkm2 <=cat_lim[5]] <- palette_cate[4]
summary.grid_to_plot$color[ summary.grid_to_plot$meanBkm2 >cat_lim[5] & summary.grid_to_plot$meanBkm2 <=max(summary.grid_to_plot[!is.na(summary.grid_to_plot$meanBkm2), "meanBkm2"])] <- palette_cate[5]
#summary.grid_to_plot$color[ summary.grid_to_plot$meanBkm2 >cat_lim[6] ] <- palette_cate[6]

summary.grid_to_plot$cate[ summary.grid_to_plot$meanBkm2 >= min(summary.grid_to_plot[!is.na(summary.grid_to_plot$meanBkm2), "meanBkm2"])  & summary.grid_to_plot$meanBkm2 <=cat_lim[2]] <- cate_label[1]
summary.grid_to_plot$cate[ summary.grid_to_plot$meanBkm2 >cat_lim[2] & summary.grid_to_plot$meanBkm2 <=cat_lim[3]] <- cate_label[2]
summary.grid_to_plot$cate[ summary.grid_to_plot$meanBkm2 >cat_lim[3] & summary.grid_to_plot$meanBkm2 <=cat_lim[4]] <- cate_label[3]
summary.grid_to_plot$cate[ summary.grid_to_plot$meanBkm2 >cat_lim[4] & summary.grid_to_plot$meanBkm2 <=cat_lim[5]] <- cate_label[4]
summary.grid_to_plot$cate[ summary.grid_to_plot$meanBkm2 >cat_lim[5] & summary.grid_to_plot$meanBkm2 <=max(summary.grid_to_plot[!is.na(summary.grid_to_plot$meanBkm2), "meanBkm2"])] <- cate_label[5]
#summary.grid_to_plot$cate[ summary.grid_to_plot$meanBkm2 >cat_lim[6] ] <- cate_label[6]

summary.grid_to_plot$to_plot[ summary.grid_to_plot$meanBkm2 >= min(summary.grid_to_plot[!is.na(summary.grid_to_plot$meanBkm2), "meanBkm2"])  & summary.grid_to_plot$meanBkm2 <=cat_lim[2]] <- 2
summary.grid_to_plot$to_plot[ summary.grid_to_plot$meanBkm2 >cat_lim[2] & summary.grid_to_plot$meanBkm2 <=cat_lim[3]] <- 3
summary.grid_to_plot$to_plot[ summary.grid_to_plot$meanBkm2 >cat_lim[3] & summary.grid_to_plot$meanBkm2 <=cat_lim[4]] <- 4
summary.grid_to_plot$to_plot[ summary.grid_to_plot$meanBkm2 >cat_lim[4] & summary.grid_to_plot$meanBkm2 <=cat_lim[5]] <- 6
summary.grid_to_plot$to_plot[ summary.grid_to_plot$meanBkm2 >cat_lim[5] & summary.grid_to_plot$meanBkm2 <=max(summary.grid_to_plot[!is.na(summary.grid_to_plot$meanBkm2), "meanBkm2"])] <- 7
 #summary.grid_to_plot$to_plot[ summary.grid_to_plot$meanBkm2 >cat_lim[6] ] <- 8

lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
ratio <- ly/lx
img_width <- 30
img_height <- img_width*ratio


jpeg(file=paste(wd, "/output/",sspp," - GFCM GRID BIOMASS.jpg", sep = ""), width=img_width, height=img_height, bg="white", units="cm",res=200)

par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
plot(1,1,type="n",xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste("Biomass (Kg/km2) -", sspp) )
plot(cgpmgrid, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")                                                                                 #data = centroidi_coords,
plot(continent, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), border="grey", col="light grey", add=T)

symbols(summary.grid_to_plot$lon[order(summary.grid_to_plot $to_plot, decreasing = T)], summary.grid_to_plot$lat[order(summary.grid_to_plot $to_plot, decreasing = T)], circles=as.numeric(as.character(summary.grid_to_plot $to_plot[order(summary.grid_to_plot $to_plot, decreasing = T)])), inches=0.12, fg="grey", bg=summary.grid_to_plot$color[order(summary.grid_to_plot $to_plot, decreasing = T)], add=T)   # inches=1
points(summary.grid_to_plot$lon[summary.grid_to_plot $to_plot==0], summary.grid_to_plot$lat[summary.grid_to_plot $to_plot==0], pch=4)   # inches=1 ,
legend(map_range[1,"xmin"],map_range[1,"ymax"], cate_label, col=palette_cate, pch = 19, pt.cex=c(1,2,2.5,3,3.3), title = "Biomass (Kg/km2)", bty = "n")

#symbols(summary.grid_to_plot$lon, summary.grid_to_plot$lat, circles=summary.grid_to_plot $meanBkm2, inches=0.3, fg="white", bg="green", add=T)

# with(centroidi_coords, text(centroidi_coords$coords.x1 - 0.5, centroidi_coords$coords.x2,  labels = centroidi_coords$cgpmgrid_id, pos = 4, cex = 0.2, col="grey"))
box()
dev.off()


# #----------------------------------------
# # Saving maps of the CV of BIOMASS index
# #----------------------------------------
#
#
# cat_lim <- quantile(summary.grid$cvBkm2[!is.na(summary.grid$cvBkm2)], probs = seq(0, 1,0.20) )
# cate_label <-  round(cat_lim,0)
#
# cate_label_min <- cate_label                                             #[2:length(cate_label)]
# cate_label_max <- cate_label[2:length(cate_label)]
#
# cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
# cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")
#
# #cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )
# cate_label <- cate_label[1: (length(cate_label)-1)]
#
# palette_cate <- heat.colors(length(cate_label))
# palette_cate <- palette_cate[length(palette_cate):1]
#
# # summary.grid_to_plot <- summary.grid
# summary.grid_to_plot$cateCV <- "0"
#
# summary.grid_to_plot$colorCV <- "black"
# summary.grid_to_plot$to_plotCV <- 0
#
# to_plot <- summary.grid_to_plot[!is.na(summary.grid_to_plot$cvBkm2) & is.finite(summary.grid_to_plot$cvBkm2),]
# to_plot_NA <- summary.grid_to_plot[is.na(summary.grid_to_plot$cvBkm2) | !is.finite(summary.grid_to_plot$cvBkm2),]
#
# to_plot$colorCV[ to_plot$cvBkm2 >= min(to_plot$cvBkm2) & to_plot$cvBkm2 <=cat_lim[2]] <- palette_cate[1]
# to_plot$colorCV[ to_plot$cvBkm2 >cat_lim[2] & to_plot$cvBkm2 <=cat_lim[3]] <- palette_cate[2]
# to_plot$colorCV[ to_plot$cvBkm2 >cat_lim[3] & to_plot$cvBkm2 <=cat_lim[4]] <- palette_cate[3]
# to_plot$colorCV[ to_plot$cvBkm2 >cat_lim[4] & to_plot$cvBkm2 <=cat_lim[5]] <- palette_cate[4]
# to_plot$colorCV[ to_plot$cvBkm2 >cat_lim[5] & to_plot$cvBkm2 <=max(to_plot$cvBkm2)] <- palette_cate[5]
# #to_plot$color[ to_plot$meanNkm2 >cat_lim[6] ] <- palette_cate[6]
#
# to_plot$cateCV[ to_plot$cvBkm2 >= min(to_plot$cvBkm2) & to_plot$cvBkm2 <=cat_lim[2]] <- cate_label[1]
# to_plot$cateCV[ to_plot$cvBkm2 >cat_lim[2] & to_plot$cvBkm2 <=cat_lim[3]] <- cate_label[2]
# to_plot$cateCV[ to_plot$cvBkm2 >cat_lim[3] & to_plot$cvBkm2 <=cat_lim[4]] <- cate_label[3]
# to_plot$cateCV[ to_plot$cvBkm2 >cat_lim[4] & to_plot$cvBkm2 <=cat_lim[5]] <- cate_label[4]
# to_plot$cateCV[ to_plot$cvBkm2 >cat_lim[5] & to_plot$cvBkm2 <=max(to_plot$cvBkm2)] <- cate_label[5]
# #to_plot$cate[ to_plot$meanNkm2 >cat_lim[6] ] <- cate_label[6]
#
# to_plot$to_plotCV[ to_plot$cvBkm2 >= min(to_plot$cvBkm2) & to_plot$cvBkm2 <=cat_lim[2]] <- 2
# to_plot$to_plotCV[ to_plot$cvBkm2 >cat_lim[2] & to_plot$cvBkm2 <=cat_lim[3]] <- 3
# to_plot$to_plotCV[ to_plot$cvBkm2 >cat_lim[3] & to_plot$cvBkm2 <=cat_lim[4]] <- 4
# to_plot$to_plotCV[ to_plot$cvBkm2 >cat_lim[4] & to_plot$cvBkm2 <=cat_lim[5]] <- 6
# to_plot$to_plotCV[ to_plot$cvBkm2 >cat_lim[5] & to_plot$cvBkm2 <=max(to_plot$cvBkm2)] <- 7
#
# jpeg(file=paste(wd, "/output/",sspp," - GFCM GRID BIOMASS CV.jpg", sep = ""), width=40, height=21, bg="white", units="cm",res=200)
#
# par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
# plot(1,1,type="n",xlim=c(-6.5,37), ylim=c(30,46), xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste("CV % of Biomass (Kg/km2) -", sspp) )
# plot(cgpmgrid, xlim=c(-6.5,37), ylim=c(30,46), add=T, border="light grey")                                                                                 #data = centroidi_coords,
# plot(continent, xlim=c(-6.5,37), ylim=c(30,46), border="grey", col="light grey", add=T)
#
# symbols(to_plot$lon[order(to_plot $to_plotCV, decreasing = T)], to_plot$lat[order(to_plot $to_plotCV, decreasing = T)], circles=as.numeric(as.character(to_plot $to_plotCV[order(to_plot $to_plotCV, decreasing = T)])), inches=0.12, fg="grey", bg=to_plot$colorCV[order(to_plot $to_plotCV, decreasing = T)], add=T)   # inches=1
# points(to_plot_NA$lon, to_plot_NA$lat, pch=4)   # inches=1 ,
# legend(-6, 43, cate_label, col=palette_cate, pch = 19, pt.cex=c(1,2,2.5,3,3.3), title = "CV % of Biomass (Kg/km2) ", bty = "n")
#
# # with(centroidi_coords, text(centroidi_coords$coords.x1 - 0.5, centroidi_coords$coords.x2,  labels = centroidi_coords$cgpmgrid_id, pos = 4, cex = 0.2, col="grey"))
# box()
# dev.off()
#
#
#
# #----------------------------------------
# # Saving maps of the inverse of CV of BIOMASS index
# #----------------------------------------
#
#
# cat_lim <- quantile(summary.grid$inverse_cvBkm2[!is.na(summary.grid$inverse_cvBkm2)], probs = seq(0, 1,0.20) )
# cate_label <-  round(cat_lim,3)
#
# cate_label_min <- cate_label                                             #[2:length(cate_label)]
# cate_label_max <- cate_label[2:length(cate_label)]
#
# cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
# cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")
# cate_label <- cate_label[1: (length(cate_label)-1)]
#
# palette_cate <- heat.colors(length(cate_label))
# palette_cate <- palette_cate[length(palette_cate):1]
#
# # summary.grid_to_plot <- summary.grid
# summary.grid_to_plot$cateCV <- "0"
#
# summary.grid_to_plot$colorCV <- "black"
# summary.grid_to_plot$to_plotCV <- 0
#
# to_plot <- summary.grid_to_plot[!is.na(summary.grid_to_plot$inverse_cvBkm2) & is.finite(summary.grid_to_plot$inverse_cvBkm2),]
# to_plot_NA <- summary.grid_to_plot[is.na(summary.grid_to_plot$inverse_cvBkm2) | !is.finite(summary.grid_to_plot$inverse_cvBkm2),]
#
# to_plot$colorCV[ to_plot$inverse_cvBkm2 >= min(to_plot$inverse_cvBkm2) & to_plot$inverse_cvBkm2 <=cat_lim[2]] <- palette_cate[1]
# to_plot$colorCV[ to_plot$inverse_cvBkm2 >cat_lim[2] & to_plot$inverse_cvBkm2 <=cat_lim[3]] <- palette_cate[2]
# to_plot$colorCV[ to_plot$inverse_cvBkm2 >cat_lim[3] & to_plot$inverse_cvBkm2 <=cat_lim[4]] <- palette_cate[3]
# to_plot$colorCV[ to_plot$inverse_cvBkm2 >cat_lim[4] & to_plot$inverse_cvBkm2 <=cat_lim[5]] <- palette_cate[4]
# to_plot$colorCV[ to_plot$inverse_cvBkm2 >cat_lim[5] & to_plot$inverse_cvBkm2 <=max(to_plot$inverse_cvBkm2)] <- palette_cate[5]
# #to_plot$color[ to_plot$meanNkm2 >cat_lim[6] ] <- palette_cate[6]
#
# to_plot$cateCV[ to_plot$inverse_cvBkm2 >= min(to_plot$inverse_cvBkm2) & to_plot$inverse_cvBkm2 <=cat_lim[2]] <- cate_label[1]
# to_plot$cateCV[ to_plot$inverse_cvBkm2 >cat_lim[2] & to_plot$inverse_cvBkm2 <=cat_lim[3]] <- cate_label[2]
# to_plot$cateCV[ to_plot$inverse_cvBkm2 >cat_lim[3] & to_plot$inverse_cvBkm2 <=cat_lim[4]] <- cate_label[3]
# to_plot$cateCV[ to_plot$inverse_cvBkm2 >cat_lim[4] & to_plot$inverse_cvBkm2 <=cat_lim[5]] <- cate_label[4]
# to_plot$cateCV[ to_plot$inverse_cvBkm2 >cat_lim[5] & to_plot$inverse_cvBkm2 <=max(to_plot$inverse_cvBkm2)] <- cate_label[5]
# #to_plot$cate[ to_plot$meanNkm2 >cat_lim[6] ] <- cate_label[6]
#
# to_plot$to_plotCV[ to_plot$inverse_cvBkm2 >= min(to_plot$inverse_cvBkm2) & to_plot$inverse_cvBkm2 <=cat_lim[2]] <- 2
# to_plot$to_plotCV[ to_plot$inverse_cvBkm2 >cat_lim[2] & to_plot$inverse_cvBkm2 <=cat_lim[3]] <- 3
# to_plot$to_plotCV[ to_plot$inverse_cvBkm2 >cat_lim[3] & to_plot$inverse_cvBkm2 <=cat_lim[4]] <- 4
# to_plot$to_plotCV[ to_plot$inverse_cvBkm2 >cat_lim[4] & to_plot$inverse_cvBkm2 <=cat_lim[5]] <- 6
# to_plot$to_plotCV[ to_plot$inverse_cvBkm2 >cat_lim[5] & to_plot$inverse_cvBkm2 <=max(to_plot$inverse_cvBkm2)] <- 7
#
# jpeg(file=paste(wd, "/output/",sspp," - GFCM GRID BIOMASS Inverse CV.jpg", sep = ""), width=40, height=21, bg="white", units="cm",res=200)
#
# par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
# plot(1,1,type="n",xlim=c(-6.5,37), ylim=c(30,46), xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste("Inverse CV % of Biomass (Kg/km2) -", sspp) )
# plot(cgpmgrid, xlim=c(-6.5,37), ylim=c(30,46), add=T, border="light grey")                                                                                 #data = centroidi_coords,
# plot(continent, xlim=c(-6.5,37), ylim=c(30,46), border="grey", col="light grey", add=T)
#
# symbols(to_plot$lon[order(to_plot $to_plotCV, decreasing = T)], to_plot$lat[order(to_plot $to_plotCV, decreasing = T)], circles=as.numeric(as.character(to_plot $to_plotCV[order(to_plot $to_plotCV, decreasing = T)])), inches=0.12, fg="grey", bg=to_plot$colorCV[order(to_plot $to_plotCV, decreasing = T)], add=T)   # inches=1
# points(to_plot_NA$lon, to_plot_NA$lat, pch=4)   # inches=1 ,
# legend(-6, 43, cate_label, col=palette_cate, pch = 19, pt.cex=c(1,2,2.5,3,3.3), title = "Inverse CV % of Biomass", bty = "n")
#
# # with(centroidi_coords, text(centroidi_coords$coords.x1 - 0.5, centroidi_coords$coords.x2,  labels = centroidi_coords$cgpmgrid_id, pos = 4, cex = 0.2, col="grey"))
# box()
# dev.off()
