metaDB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)
map_range <- read.csv(paste(wd, "/input/GSAs_coordinates.csv", sep=""), sep=";")
map_range <- map_range[map_range$GSA == unique(metaDB$GSA) & map_range$COUNTRY %in% as.character(unique(metaDB$COUNTRY)) , ]

if (nrow(map_range)>1) {
  if (check_country=="Y") {
    x1 <- min(map_range$xmin)
    x2 <- max(map_range$xmax)
    y1 <- min(map_range$ymin)
    y2 <- max(map_range$ymax)
    map_range <- map_range[1,]
    map_range[1,3] <- x1
    map_range[1,4] <- x2
    map_range[1,5] <- y1
    map_range[1,6] <- y2
  }
}

#----------------------------------------
# Saving maps of the sex-ratio by grid
#----------------------------------------
cat_lim <- quantile(sex_ratio$ratio[!is.na(sex_ratio$ratio)], probs = seq(0, 1,0.20) )
# centroidi <- data.frame(readOGR(paste(getwd(), "/scripts/utilities/gfcm-centroidi/gfcm-centroidi.shp", sep=""), verbose=F))
# centroidi_coords <- data.frame(centroidi$GFCM_ID, centroidi$lon_centr, centroidi$lat_cent)
# colnames(centroidi_coords) <- c("cgpmgrid_id", "lon", "lat")

cate_label <-  round(cat_lim,3)

cate_label_min <- cate_label
cate_label_max <- cate_label[2:length(cate_label)]

cate_label <- paste("(", cate_label_min, ", ", cate_label_max, "]", sep="")
cate_label[1] <- paste("[", cate_label_min[1], ", ", cate_label_max[1], "]", sep="")

#cate_label[length(cate_label)] <- paste(">", cate_label_max[length(cate_label_max)] )
cate_label <- cate_label[1: (length(cate_label)-1)]

palette_cate <- heat.colors(length(cate_label))
palette_cate <- palette_cate[length(palette_cate):1]

cgpmgrid@data$SR <- NA
cgpmgrid@data$color <- "#FFFFFF"

i=1
for (i in 1:length(sex_ratio[,1])){
  cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- sex_ratio[i,"ratio"]

  if (all(is.na(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]]) )){
    cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- "#FFFFFF"
  } else {

    if(all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <= cat_lim[2])  & all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] >= cat_lim[1])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- palette_cate[1]
    }

    if(all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <= cat_lim[3])  & all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] > cat_lim[2])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- palette_cate[2]
    }

    if(all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <= cat_lim[4])  & all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] > cat_lim[3])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- palette_cate[3]
    }

    if(all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <= cat_lim[5])  & all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] > cat_lim[4])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- palette_cate[4]
    }

    if(all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <= cat_lim[6])  & all(cgpmgrid@data$SR[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] > cat_lim[5])){
      cgpmgrid@data$color[cgpmgrid@data$GFCM_ID==sex_ratio[i,"cgpmgrid_id"]] <- palette_cate[5]
    }
  }
}


lx =map_range[1,"xmax"] - map_range[1,"xmin"]
ly =map_range[1,"ymax"] - map_range[1,"ymin"]
ratio <- ly/lx
img_width <- 30
img_height <- img_width*ratio

# jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID Sex Ratio.jpg", sep = ""), width=img_width, height=img_height, bg="white", units="cm",res=200)
jpeg(file=paste(getwd(), "/output/",sspp," - GFCM GRID Sex Ratio.jpg", sep = ""), width=25, height=25, bg="white", units="cm",res=200)
par( mar=c(4, 5, 4, 2)) #c(bottom, left, top, right)
plot(1,1,type="n",xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), xlab=expression(paste("Longitude (",degree,"E)")), ylab=expression(paste("Latitude (",degree,"N)")), main=paste("sex ratio -", sspp, " GSA", GSA),asp=1 )
plot(cgpmgrid, col=cgpmgrid$color, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")                                                                                 #data = centroidi_coords,
if (depthstr == "200-800" | depthstr == 3){
  plot(mask,col="white", xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), add=T, border="light grey")
}
plot(continent, xlim=c(map_range[1,"xmin"],map_range[1,"xmax"]), ylim=c(map_range[1,"ymin"],map_range[1,"ymax"]), border="grey", col="light grey", add=T)
legend("topleft", cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "sex ratio\n(classes based on percentiles)", bty = "n")
# legend(map_range[1,"xmin"], map_range[1,"ymax"], cate_label, col=palette_cate, pch = 15, pt.cex=c(2), title = "sex ratio\n(classes based on percentiles)", bty = "n")
box()
dev.off()
