metaDBnew <- data.frame(read.csv(paste(wd, "/output/",sspp," - allGSAs_metaDB_catch in GRID.csv",sep=""), sep=";"))
years <- sort(unique(metaDBnew$YEAR))

if (length(years) < 10) {
  n_years <- as.numeric(dlgInput(paste("There are less than 10 years (", length(years),") of survey\nHow many of the last  years do you want to consider in the analysis? --> ", sep=""), default="",Sys.info()[""])$res)
  firstyear <- years[length(years)-(n_years-1)]
  last_10years <- years[years >= firstyear]
} else {
  firstyear <- years[length(years)-9]
  last_10years <- years[years >= firstyear]
}

metaDBnew <- metaDBnew[metaDBnew$YEAR %in% last_10years & metaDBnew$TOTAL_NUMBER_IN_THE_HAUL > threshold, ]  #
metaDBnew <- metaDBnew[metaDBnew$MEAN_DEPTH > depth_range[1] & metaDBnew$MEAN_DEPTH <= depth_range[2], ]  #


if (nrow(metaDBnew)==0){
  cat("Not enough data for the sex ratio estimation.\nTry again reducing the threshold value.\n")
  sexratio_grid_skip <- TRUE
} else {

  if ( all(metaDBnew$NB_OF_FEMALES == 0) & all(metaDBnew$NB_OF_MALES == 0) ) {
    cat("No sex information available in TC for the selected species. Sex-ratio estimation is not possible")
    sexratio_grid_skip <- TRUE
  } else {

  grid_id <- unique(metaDBnew$cgpmgrid_id)
  sex_ratio <- data.frame(matrix(NA, nrow=length(grid_id), ncol=4))
  colnames(sex_ratio) <- c("cgpmgrid_id", "ratio", "sd", "CV")
  sex_ratio[,1] <-grid_id

i=3
for (i in 1:length(grid_id)){
  dd <- metaDBnew[metaDBnew$cgpmgrid_id == grid_id[i], ]
  dd$nkm2_F <- dd$NB_OF_FEMALES/dd$SWEPT_AREA
  dd$nkm2_M <- dd$NB_OF_MALES/dd$SWEPT_AREA
  dd$nkm_FM <- (dd$NB_OF_MALES + dd$NB_OF_FEMALES)/dd$SWEPT_AREA
  dd$sr_haul<- dd$nkm2_F / dd$nkm_FM

  nkm_F <- sum(dd$nkm2_F)
  nkm_M <- sum(dd$nkm2_M)
  nkm_FM <- sum(dd$nkm_FM)
  sex_ratio[i,2] <- nkm_F/nkm_FM
  sex_ratio[i,3] <- sqrt(sum((sex_ratio[i,2] - dd$sr_haul)^2)/length(dd$sr_haul))
  sex_ratio[i,4] <- sex_ratio[i,3]/sex_ratio[i,2]
}

write.table(sex_ratio, paste(wd, "/output/",sspp," - GFCM SEX RATIO.csv", sep=""), sep=";", row.names=FALSE)

source (paste(wd,"/scripts/plotGFCM_sex_ratio.r", sep=""))
  }
}



