library(ggplot2)
library(svDialogs)

merge_TATB <- read.table(paste(wd, "/output/mergeTATB_",GENERE, SPECIE,".csv", sep=""), sep=";",header = T)

GENERE <- as.character(unique(merge_TATB$GENUS)[unique(merge_TATB$GENUS) != -1])
SPECIE <- as.character(unique(merge_TATB$SPECIES)[unique(merge_TATB$SPECIES) != -1])
sspp <- paste(GENERE,SPECIE, sep="")
GSA <- unique(merge_TATB$GSA)
species <- sspp
# plotting species' depth range information

ddd <- merge_TATB
ddd$NB_FM <- ddd$NB_OF_FEMALES + ddd$NB_OF_MALES
year_range <- data.frame(year = sort(unique(merge_TATB$YEAR)))

res_table_calaF <- data.frame(year=sort(unique(merge_TATB$YEAR)))
res_table_calaF$index_F <- NA


res_table_calaFM <- data.frame(year=sort(unique(merge_TATB$YEAR)))
res_table_calaFM$index_FM <- NA


SR <- data.frame(year=sort(unique(merge_TATB$YEAR)))
SR$Indices_F <- NA
SR$Indices_FM <- NA
SR$sr <- NA
SR$variance <- NA


i=1
for(i in 1:length(res_table_cala2[,1])) {
  
  data2 <- ddd[ddd$YEAR == res_table_cala2[i,1] , ]

    s_nF <- sum(data2[!is.na(data2$NB_OF_FEMALES),"NB_OF_FEMALES"])
    s_nFM <- sum(data2[!is.na(data2$NB_FM),"NB_FM"])
    s_a <- sum(data2$SWEPT_AREA)
    res_table_calaF[i,2] <- s_nF/s_a
    res_table_calaFM[i,2] <- s_nFM/s_a
  
  positive_hauls[i] <- length(merge_TATB[merge_TATB$TOTAL_NUMBER_IN_THE_HAUL>0 & merge_TATB$YEAR == res_table_cala2[i,1],"TOTAL_NUMBER_IN_THE_HAUL"])

  SR$year[i] <- res_table_calaF$year[i]
  SR$Indices_F[i] <- res_table_calaF[i,2]
  SR$Indices_FM[i] <- res_table_calaFM[i,2]
  SR$sr[i] <- SR$Indices_F[i] / SR$Indices_FM[i]
  SR$variance[i] <- sqrt(SR$sr[i]*(1-SR$sr[i]))/res_table_calaFM[i,2]
  
}
  
timeseries <-SR


# plot sex-ratio   
    main <- paste(sspp,"_GSA",GSA,"_(Sex ratio)-Simple_Random_Sampling_", sep="")
    main.lab <- paste(sspp," GSA",GSA," (Sex ratio)-SRS ", sep="")
    sd_sr <- sqrt(timeseries[!is.na(timeseries$variance),"variance"])
    max_index <- 1 + (max(sd_sr[!is.na(sd_sr)])*1.2)
    write.table(timeseries, paste(wd,"/output/",main,"_Timeseries.csv", sep=""), sep=";", row.names = F)

    tiff(paste(wd,"/output/",main,"_Timeseries.tiff",sep=""), res = 300, width = 8, height = 7, units = 'in', compression = 'lzw', pointsize = 1/300)
    par(mfrow=c(1,1),oma=c(1,1,1,1), mgp=c(2, 1,0)) 
    plot(timeseries[,1],  timeseries[,4], type="b", col="black", pch=16, xlab="year", ylim=c(0,max_index*1.2), ylab="sex ratio (FF/(FF+MM))", main=main.lab) # ylim=c(0,max_index*1.2)
    lines(timeseries[,1], (timeseries[,4]-1.96*sqrt(timeseries[,5])), type="l",lty=2, col="red" )
    lines(timeseries[,1], (timeseries[,4]+1.96*sqrt(timeseries[,5])), type="l",lty=2, col="red" )
    legend("topright", c("Sex ratio"), lty=c(1,2), pch=c(16), col=c("black"))
    dev.off()
