
spear<-function (x){

N = length(x)
S = rank(x,ties.method ="min") # crank(x)
R = c(1:length(x))

r = 1-6*sum((R-S)^2)/N/(N^2-1)
    t=r*sqrt((N-2)/(1-r^2))

p=2*(1-pt(abs(t),N-2)) #
results=data.frame(r=r,t=t,p=p)
return(results)
}

print("Select the year range for the analysis")
yrange <- dlgInput("Year range for the analysis: ", default=paste(min(years),max(years),sep=","),Sys.info()[""])$res
yrange <- data.frame(range = as.numeric(strsplit(yrange, ",")[[1]]))
rownames(yrange) <- c("start", "end")
#----------------------------
# Abundance indices
#----------------------------
timeseries <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(abundance)-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)

years_sel <- (yrange[1,1]:yrange[2,1])
timeseries <- timeseries[timeseries$year %in% years_sel , ]
x=log(timeseries[,2]+1)
spear(x)
spearman_abundance <- spear(x)

#----------------------------
# Biomass indices
#----------------------------
timeseries <- read.table(paste(wd, "/output/",sspp,"_GSA",GSA,"_(biomass)-Simple_Random_Sampling__Timeseries.csv", sep=""), sep=";", header=T)
years <- (yrange[1,1]:yrange[2,1])
timeseries <- timeseries[timeseries$year %in% years_sel , ]
x=log(timeseries[,2]+1)
spear(x)
spearman_biomass <- spear(x)


#----------------------------
# Results in table
#----------------------------
vars <- c("abundance" , "biomass")
tab <- rbind(spearman_abundance , spearman_biomass)
tab_spearman <- data.frame(index = vars, tab)
print(tab_spearman)
write.table(tab_spearman, paste(wd, "/output/",sspp," - Spearman summary_SRS.csv", sep=""), sep=";", row.names=FALSE)
